Components.utils.import("resource://modules/kclobserver.jsm");
Components.utils.import("resource://gre/modules/ctypes.jsm");
Components.utils.import("resource://gre/modules/osfile.jsm")

const Cc = Components.classes;
const Ci = Components.interfaces;


const defEnemySet = '{"eset_num":0,"eset_list":{},"eset_taiku":0}';
const defBlankMasterItem = '{"api_id":0,"api_sortno":0,"api_name":"","api_type":[0,0,0,0],"api_taik":0,"api_souk":0,"api_houg":0,"api_raig":0,"api_soku":0,"api_baku":0,"api_tyku":0,"api_tais":0,"api_atap":0,"api_houm":0,"api_raim":0,"api_houk":0,"api_raik":0,"api_bakk":0,"api_saku":0,"api_sakb":0,"api_luck":0,"api_leng":0,"api_rare":0,"api_broken":[0,0,0,0],"api_info":"","api_usebull":"0"}';

const defBlankMasterShip = '{"api_id":0,"api_sortno":0,"api_name":"","api_yomi":"","api_stype":0,"api_ctype":0,"api_cnum":0,"api_enqflg":"0","api_afterlv":0,"api_aftershipid":"0","api_taik":[0,0],"api_souk":[0,0],"api_tous":[0,0],"api_houg":[0,0],"api_raig":[0,0],"api_baku":[0,0],"api_tyku":[0,0],"api_atap":[0,0],"api_tais":[0,0],"api_houm":[0,0],"api_raim":[0,0],"api_kaih":[0,0],"api_houk":[0,0],"api_raik":[0,0],"api_bakk":[0,0],"api_saku":[0,0],"api_sakb":[0,0],"api_luck":[0,0],"api_sokuh":0,"api_soku":0,"api_leng":0,"api_grow":[0,0,0,0,0,0,0,0],"api_slot_num":0,"api_maxeq":[0,0,0,0,0],"api_defeq":[0,0,0,0],"api_buildtime":0,"api_broken":[0,0,0,0],"api_powup":[0,0,0,0],"api_gumax":[0,0,0,0],"api_backs":0,"api_getmes":"","api_homemes":null,"api_gomes":null,"api_gomes2":null,"api_sinfo":"","api_afterfuel":0,"api_afterbull":0,"api_touchs":[null,null,null],"api_missions":null,"api_systems":null,"api_fuel_max":0,"api_bull_max":0,"api_voicef":0}';

const defBlankMemberShip = '{"api_id":0,"api_sortno":0,"api_ship_id":0,"api_lv":0,"api_exp":[0,0,0],"api_nowhp":0,"api_maxhp":0,"api_leng":0,"api_slot":[0,0,0,0,0],"api_onslot":[0,0,0,0,0],"api_kyouka":[0,0,0,0,0],"api_backs":0,"api_fuel":0,"api_bull":0,"api_slotnum":0,"api_ndock_time":0,"api_ndock_item":[0,0],"api_srate":0,"api_cond":0,"api_karyoku":[0,0],"api_raisou":[0,0],"api_taiku":[0,0],"api_soukou":[0,0],"api_kaihi":[0,0],"api_taisen":[0,0],"api_sakuteki":[0,0],"api_lucky":[0,0],"api_locked":0}';

function debugprint(str){
    let aConsoleService = Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService);
    aConsoleService.logStringMessage(str);
}

function dID(elm){
    return document.getElementById(elm);
}

var StatusBarTimer;
var StatusBarTimer2;
var StatusBarMode;
var hw_prefs;
var hw_Branch;
var bundle;
var eData;

var KclInsp = {

    init: function(){
try{
    KclHttpObserver.init();
    KclHttpObserver.addCallback(KclInspCallback);
    StatusBarMode = 0;
    StatusBarTimer = setInterval(function(){UpdateStatusBar();}, 1000);
    StatusBarTimer2 = setInterval(function(){UpdateStatusBarMode();}, 5000);

    bundle = dID("kclinsp-bundle");
    hw_prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
    hw_Branch = hw_prefs.getBranch("extensions.kclinsp.");

    let enemysets =""
    try{
        enemysets = hw_Branch.getCharPref("enemysets");
    }catch(e){
        enemysets = "";
    }
    if(enemysets.length > 0){
        eData = {};
        eData['edata'] = [];
        eData.edata.push(JSON.parse(defEnemySet));
        setKclEnemySetsPref()
        hw_Branch.clearUserPref("enemysets", "")
    }else{
        getKclEnemySetsPref()
    }
    getBasicPref();

}catch(e){
    debugprint(e);
}
    },

    destroy: function(){
        KclHttpObserver.removeCallback(KclInspCallback);
        KclHttpObserver.destroy();
        clearInterval(StatusBarTimer);
        clearInterval(StatusBarTimer2);
    }
}


function getQueryString(str){
    let tstr = str.split("&");
    let rstr = [];
    for(let i in tstr){
        let rst = tstr[i].split("=");
        let rst2 = decodeURIComponent(rst[1]);
        if(rst2.indexOf(",") > 0){
            rstr[decodeURIComponent(rst[0])] = rst2.split(",");
        }else{
            rstr[decodeURIComponent(rst[0])] = rst2;
        }
    }
    return rstr;
}

function KclInspCallback(reqURL, str, rstr, scd){
    let url = reqURL;

try{


if(url.match(/kcsapi/)){

    let data = JSON.parse(str.substring(str.indexOf('svdata=') + 7));
    let rdata = getQueryString(rstr.substring(rstr.indexOf("\r\n\r\n") + 4));

    if(typeof data.api_result === "undefined"){
        UpdateSortieLog(getBStr("TRANSFERERR"));
    }else if(data.api_result != 1){
        UpdateSortieLog(data.api_result_msg + "(" + url + ")");

//////////////////
//api_get_master
//////////////////
    }else if(url.match(/kcsapi\/api_get_master\/ship$/)){
        KclInfo.gMasterShip = data.api_data;

    }else if(url.match(/kcsapi\/api_start2$/)){
        setBasicPref(data);
        KclInfo.gapi_start2 = data;
        KclInfo.gMasterShip = data.api_data.api_mst_ship;
        KclInfo.gMasterItem = data.api_data.api_mst_slotitem;
        KclInfo.gMapInfo = data.api_data.api_mst_mapinfo;
        KclInfo.gMapCell = data.api_data.api_mst_mapcell;
        KclInfo.gMasterQuestList = data.api_data.api_mst_mission;

//////////////////
//api_get_member
//////////////////
    }else if(url.match(/kcsapi\/api_get_member\/deck$/)){
        KclInfo.gMemberFleet = data.api_data;
        UpdateFleetList();

    }else if(url.match(/kcsapi\/api_get_member\/ship2$/)){
        KclInfo.gMemberShip = data.api_data;
        KclInfo.gMemberFleet = data.api_data_deck;
        initShipTree();
        UpdateBaseInfo();
        initItemTree();

    }else if(url.match(/kcsapi\/api_get_member\/ship3$/)){
        UpdateMemberShipList(data.api_data.api_ship_data);
        KclInfo.gMemberFleet = data.api_data.api_deck_data;
        initShipTree();
        UpdateBaseInfo();
        initItemTree();

    }else if(url.match(/kcsapi\/api_get_member\/ship$/)){
        KclInfo.gMemberShip = data.api_data;

    }else if(url.match(/kcsapi\/api_get_member\/questlist$/)){
        let aRec = KclInfo.gQuestList.api_record;
        KclInfo.gQuestList = data.api_data;
        KclInfo.gQuestList.api_record = aRec;
        UpdateQuestList();
        initQuestTree();
        KclInfo.gQuestList.api_record = false;

    }else if(url.match(/kcsapi\/api_get_member\/record$/)){
        KclInfo.gQuestList.api_record = true;

    }else if(url.match(/kcsapi\/api_get_member\/slot_item$/)){
        KclInfo.gMemberItem = data.api_data;
        UpdateBaseInfo();
        initItemTree();

    }else if(url.match(/kcsapi\/api_get_member\/ndock$/)){
        KclInfo.gMemberNDock = data.api_data;

    }else if(url.match(/kcsapi\/api_get_member\/kdock$/)){
        if(typeof KclInfo.gMemberKDock.api_kdock_id !== "undefined"){
            let api_kdock_id = KclInfo.gMemberKDock.api_kdock_id;
            KclInfo.gMemberKDock = data.api_data;
            UpdateCreateShipLog(api_kdock_id);
        }else{
            KclInfo.gMemberKDock = data.api_data;
        }

    }else if(url.match(/kcsapi\/api_port\/port$/)){
        KclInfo.gMaterial = data.api_data.api_material;
        KclInfo.gMemberShip = data.api_data.api_ship;
        KclInfo.gMemberFleet = data.api_data.api_deck_port;
        KclInfo.gMemberFleet[0].api_combined_flag = data.api_data.api_combined_flag
//debugprint("combined flag:" + KclInfo.gMemberFleet[0].api_combined_flag);
        initShipTree();
        initItemTree();
        KclInfo.gMemberNDock = data.api_data.api_ndock;
        KclInfo.gMemberBasic = data.api_data.api_basic;
        UpdateBaseInfo();

    }else if(url.match(/kcsapi\/api_req_hensei\/change$/)){
        ChangeFleetList(rdata);
        UpdateFleetList();

    }else if(url.match(/kcsapi\/api_req_hokyu\/charge$/)){
        UpdateSupply(data.api_data);
        UpdateBaseInfo();
        initShipTree();

//////////////////
//api_req_kousyou
//////////////////
    }else if(url.match(/kcsapi\/api_req_kousyou\/destroyitem2$/)){
        DeleteMemberItemList(rdata.api_slotitem_ids);
        UpdateBaseInfo();
        initItemTree();

    }else if(url.match(/kcsapi\/api_req_kousyou\/destroyship$/)){
        DeleteMemberShip(rdata.api_ship_id);
        initShipTree();
        UpdateBaseInfo();
        initItemTree();

    }else if(url.match(/kcsapi\/api_req_kousyou\/createitem$/)){
        UpdateCreateItem(data, rdata)
        UpdateBaseInfo();
        initItemTree();

    }else if(url.match(/kcsapi\/api_req_kousyou\/createship$/)){
try{
        if(hw_Branch.getBoolPref("createshiplog")){
            KclInfo.gMemberKDock['api_kdock_id'] = rdata.api_kdock_id;
        }
}catch(e){
    UpdateSortieLog(e);
}

    }else if(url.match(/kcsapi\/api_req_kousyou\/getship$/)){
        KclInfo.gMemberKDock = data.api_data.api_kdock;
        AddMemberItemList(data.api_data.api_slotitem);
        AddMemberShip(data.api_data.api_ship);
        initShipTree();
        UpdateBaseInfo();
        initItemTree();

//////////////////
//api_req_kaisou
//////////////////
    }else if(url.match(/kcsapi\/api_req_kaisou\/powerup$/)){
        DeleteMemberShip(rdata.api_id_items);
        if(data.api_data.api_powerup_flag == 1){
            let tmpShip = new Array(data.api_data.api_ship);
            UpdateMemberShipList(tmpShip);
            KclInfo.gMemberFleet = data.api_data.api_deck;
        }
        initShipTree();
        UpdateBaseInfo();
        initItemTree();

    }else if(url.match(/kcsapi\/api_get_member\/basic$/)){
        KclInfo.gMemberBasic = data.api_data;
        UpdateBaseInfo();

//////////////////
//api_req_mission
//////////////////
    }else if(url.match(/kcsapi\/api_req_mission\/start$/)){
        UpdateMissionLog(data, rdata);

//////////////////
//api_req_nyukyo
//////////////////
    }else if(url.match(/kcsapi\/api_req_nyukyo\/start$/)){
        UpdateNdock(rdata);
        UpdateBaseInfo();
        initShipTree();

    }else if(url.match(/kcsapi\/api_req_nyukyo\/speedchange$/)){
        HighspeedNdock(KclInfo.gMemberNDock[+rdata.api_ndock_id - 1].api_ship_id);
        UpdateBaseInfo();
        initShipTree();

//////////////////
//api_req_map-battle
//////////////////
    }else if(url.match(/kcsapi\/api_req_map\/start$/)){
        KclInfo.gMapRequest = data.api_data;
        KclInfo.gMapRequest.Direction = "Start:"
        UpdateMapInfoLog(rdata);
        UpdateProgressLog();

    }else if(url.match(/kcsapi\/api_req_map\/next$/)){
        KclInfo.gMapRequest = data.api_data;
        KclInfo.gMapRequest.Direction = "Next:"
        UpdateProgressLog();

    }else if(url.match(/kcsapi\/api_req_sortie\/battle$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcBattleLog();

    }else if(url.match(/kcsapi\/api_req_battle_midnight\/battle$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcMidnightBattleLog();

    }else if(url.match(/kcsapi\/api_req_practice\/battle$/)){
        KclInfo.gBattle = data.api_data;
        if(!KclInfo.gMapRequest.api_enemy){
            KclInfo.gMapRequest.api_enemy = [];
        }
        KclInfo.gMapRequest.api_enemy.api_enemy_id = "-";
        UpdateSortieLog(getBStr("PRACTICE"))
        UpdateBattleLog();
        calcBattleLog();

    }else if(url.match(/kcsapi\/api_req_practice\/midnight_battle$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcMidnightBattleLog();

    }else if(url.match(/kcsapi\/api_req_battle_midnight\/sp_midnight$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcMidnightBattleLog();

    }else if(url.match(/kcsapi\/api_req_sortie\/night_to_day$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcNightToDayBattleLog();

    }else if(url.match(/kcsapi\/api_req_sortie\/battleresult$/)){
        KclInfo.gBattleResult = data.api_data;
        UpdateBattleResultLog();

//////////////////
//api_req_combined_battle
//////////////////
    }else if(url.match(/kcsapi\/api_req_combined_battle\/airbattle$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcCombinedAirBattleLog()
    }else if(url.match(/kcsapi\/api_req_combined_battle\/battle$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcCombinedBattleLog()

    }else if(url.match(/kcsapi\/api_req_combined_battle\/battle_water$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcCombinedWaterBattleLog()

    }else if(url.match(/kcsapi\/api_req_combined_battle\/midnight_battle$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcCombinedMidnightBattleLog()
    }else if(url.match(/kcsapi\/api_req_combined_battle\/battleresult$/)){
        KclInfo.gBattleResult = data.api_data;
        UpdateCombinedBattleResultLog()
    }else if(url.match(/kcsapi\/api_req_combined_battle\/sp_midnight$/)){
        KclInfo.gBattle = data.api_data;
        UpdateBattleLog();
        calcCombinedMidnightBattleLog()

    }else if(url.match(/kcsapi\/api_get_member\/mapinfo$/)){
        UpdateMapInfo(data.api_data);
    }
}else{
    try{
        let gLogFile = hw_Branch.getComplexValue("capturefiles", Ci.nsISupportsString).data;
        if(gLogFile != ""){
//            if(scd == "200"){
                let rpath = url.replace(/http.*?\/\/.*?\//, "");
                rpath = rpath.replace(/\?/g, "_");
                let tpath = rpath.split("/");
                rpath = gLogFile;
                for(let i in tpath){
                    rpath = OS.Path.join(rpath, tpath[i]);
                }
            if(scd == "200"){
                writeToFileBin(rpath, str, "o");
            }else{
                writeToFileBin(rpath, str, "o");
            }
//                writeToFileBin(rpath, str, "o");
//            }
        }
    }catch(e){
        UpdateSortieLog(url + "\n" + e);
    }
    }

}catch(e){
    UpdateSortieLog(url + "\n" + e);
    throw e;
}
}

function UpdateCreateItem(data, rdata){
try{
    let ritem = data.api_data.api_slot_item;
    if(typeof ritem !== "undefined"){
        ritem = data.api_data.api_slot_item.api_slotitem_id;
        ritem = KclInfo.gMasterItem[+ritem - 1].api_name;
    }
    let fitem = data.api_data.api_fdata;
    if(typeof fitem !== "undefined"){
        fitem = fitem.split(",");
        let ffitem = fitem[0] + "," + KclInfo.gMasterItem[+fitem[1] - 1].api_name;
        fitem = ffitem;
    }
    msShip = SearchMasterShip(KclInfo.gMemberFleet[0].api_ship[0]);
    memShip = SearchMemberShip(KclInfo.gMemberFleet[0].api_ship[0]);
    if(hw_Branch.getBoolPref("createitemlog")){
        UpdateSortieLog(getBStr("KDEV") +
                                        "[" + KclInfo.gMemberBasic.api_level + "]" +
                                        "[" + msShip.api_name + ":" + memShip.api_lv + "]" + 
                                        rdata.api_item1 + "/" + 
                                        rdata.api_item2 + "/" + 
                                        rdata.api_item3 + "/" + 
                                        rdata.api_item4 + ":" + 
                                        ritem + "/" + 
                                        fitem);
    }
    if(typeof ritem !== "undefined"){
        AddMemberItemList(new Array(data.api_data.api_slot_item));
    }
    if(data.api_data.api_shizai_flag == 1){
        KclInfo.gMaterial[6].api_value = +KclInfo.gMaterial[6].api_value - 1;
    }

    KclInfo.gMaterial[0].api_value = data.api_data.api_material[0];
    KclInfo.gMaterial[1].api_value = data.api_data.api_material[1];
    KclInfo.gMaterial[2].api_value = data.api_data.api_material[2];
    KclInfo.gMaterial[3].api_value = data.api_data.api_material[3];
}catch(e){
    UpdateSortieLog(e);
}
}

function UpdateNdock(tObj){
    if(tObj.api_highspeed == 1){
        HighspeedNdock(tObj.api_ship_id);
    }
}

function HighspeedNdock(ship_id){
    for(let i in KclInfo.gMemberShip){
        if(KclInfo.gMemberShip[i].api_id == ship_id){
            KclInfo.gMemberShip[i].api_nowhp = KclInfo.gMemberShip[i].api_maxhp;
            KclInfo.gMemberShip[i].api_ndock_time = 0;
            KclInfo.gMemberShip[i].api_ndock_item[0] = 0;
            KclInfo.gMemberShip[i].api_ndock_item[1] = 0;
            KclInfo.gMaterial[5].api_value = +KclInfo.gMaterial[5].api_value - 1;
            break
        }
    }
}

function AddMemberItemList(tObj){
    for(let i in tObj){
        KclInfo.gMemberItem.push(tObj[i]);
    }
}

function AddMemberShip(tObj){
    KclInfo.gMemberShip.push(tObj);
}

function DeleteMemberItemList(tObj){
    if(tObj instanceof Array){
        for(let i in tObj){
            if(tObj[i] > 0){
                for(let j in KclInfo.gMemberItem){
                    if(tObj[i] == KclInfo.gMemberItem[j].api_id){
                        KclInfo.gMemberItem.splice(j, 1);
                        break;
                    }
                }
            }
        }
    }else{
        if(tObj > 0){
            for(let j in KclInfo.gMemberItem){
                if(tObj == KclInfo.gMemberItem[j].api_id){
                    KclInfo.gMemberItem.splice(j, 1);
                    break;
                }
            }
        }
    }
}

function DeleteMemberShip(tID){
    let ship_id = tID;
    if(ship_id instanceof Array){
    }else{
        ship_id = new Array(ship_id);
    }
    for(let f in ship_id){
        if(ship_id[f] > 0){
            let memShip = SearchMemberShip(ship_id[f])
            DeleteMemberItemList(memShip.api_slot);
            for(let j in KclInfo.gMemberShip){
                if(ship_id[f] == KclInfo.gMemberShip[j].api_id){
                    KclInfo.gMemberShip.splice(j, 1);
                    break;
                }
            }
            for(let i in KclInfo.gMemberFleet){
                for(let j in KclInfo.gMemberFleet[i].api_ship){
                    if(ship_id[f] == KclInfo.gMemberFleet[i].api_ship[j]){
                        for(let p = j; p < 5; p++){
                            KclInfo.gMemberFleet[i].api_ship[p] = KclInfo.gMemberFleet[i].api_ship[+p + 1];
                        }
                        KclInfo.gMemberFleet[i].api_ship[5] = -1;
                        break;
                    }
                }
            }
        }
    }
}

function UpdateSupply(tObj){
    for(let i in tObj.api_ship){
        for(let j in KclInfo.gMemberShip){
            if(tObj.api_ship[i].api_id == KclInfo.gMemberShip[j].api_id){
                KclInfo.gMemberShip[j].api_fuel = tObj.api_ship[i].api_fuel;
                KclInfo.gMemberShip[j].api_bull = tObj.api_ship[i].api_bull;
                KclInfo.gMemberShip[j].api_onslot = tObj.api_ship[i].api_onslot;
                break;
            }
        }
    }
    KclInfo.gMaterial[0].api_value = tObj.api_material[0];
    KclInfo.gMaterial[1].api_value = tObj.api_material[1];
    KclInfo.gMaterial[2].api_value = tObj.api_material[2];
    KclInfo.gMaterial[3].api_value = tObj.api_material[3];
}

function ChangeFleetList(tObj){
    let FltNo = +tObj.api_id -1;
    let gMF = KclInfo.gMemberFleet[+tObj.api_id -1];
    if(tObj.api_ship_id == -2){
        gMF.api_ship[1] = -1;
        gMF.api_ship[2] = -1;
        gMF.api_ship[3] = -1;
        gMF.api_ship[4] = -1;
        gMF.api_ship[5] = -1;
    }else if(tObj.api_ship_id == -1){
        for(let i = +tObj.api_ship_idx ; i < 5 ; i++){
            gMF.api_ship[i] = gMF.api_ship[+i + 1];
        }
        gMF.api_ship[5] = -1
    }else{
        for(let i in gMF.api_ship){
            if(gMF.api_ship[i] == tObj.api_ship_id){
                gMF.api_ship[i] = gMF.api_ship[tObj.api_ship_idx];
            }
        }
        gMF.api_ship[tObj.api_ship_idx] = tObj.api_ship_id;
    }
}

function UpdateMapInfo(tObjs){
    for(let i in KclInfo.gMapInfo){
        for(let j in tObjs){
            if(KclInfo.gMapInfo[i].api_id == tObjs[j].api_id){
                for(let k in tObjs[j]){
                    KclInfo.gMapInfo[i][k] = tObjs[j][k];
                }
//debugprint("updmp:1"+JSON.stringify(KclInfo.gMapInfo[i]))
//debugprint("updmp:2"+JSON.stringify(tObjs[j]))

            }
        }
    }
}

function UpdateMemberShipList(tObj){
    for(let i in KclInfo.gMemberShip){
        for(let j in tObj){
            if(KclInfo.gMemberShip[i].api_id == tObj[j].api_id){
                KclInfo.gMemberShip[i] = tObj[j];
            }
        }
    }
}

function UpdateCreateShipLog(kdock_id){
    for(let i in KclInfo.gMemberKDock){
        if(KclInfo.gMemberKDock[i].api_id == kdock_id){
            let msg = getBStr("KDOCK") + 
                      "[" + KclInfo.gMemberKDock[i].api_item1 + "/" +
                            KclInfo.gMemberKDock[i].api_item2 + "/" +
                            KclInfo.gMemberKDock[i].api_item3 + "/" +
                            KclInfo.gMemberKDock[i].api_item4 + "]" +
                      "[" + KclInfo.gMemberKDock[i].api_item5 + "]:" +
                      SearchMasterShipByID(KclInfo.gMemberKDock[i].api_created_ship_id).api_name;
            UpdateSortieLog(msg);
        }
    }
}

function MaterialLog(){
    let msg = getBStr("ITEMGET")
            +KclInfo.gMaterial[0].api_value + "/" 
            + KclInfo.gMaterial[1].api_value + "/" 
            + KclInfo.gMaterial[2].api_value + "/" 
            + KclInfo.gMaterial[3].api_value + ":[" 
            + KclInfo.gMaterial[4].api_value + "/" 
            + KclInfo.gMaterial[5].api_value + "/" 
            + KclInfo.gMaterial[6].api_value + "/" 
            + KclInfo.gMaterial[7].api_value + "]" 
    UpdateSortieLog(msg);
}

function UpdateBattleResultLog(){
    let gMR = KclInfo.gMapRequest;
    let gBR = KclInfo.gBattleResult;
try{
    let dispsortiebattleresult = hw_Branch.getBoolPref("dispsortiebattleresult");
    if(dispsortiebattleresult){
        let gmapID =  "[" 
                   + gMR.api_maparea_id + "-" 
                   + gMR.api_mapinfo_no + "-" 
                   + gMR.api_no + "]" + " "
                   + getBStr("BATTLERESUT");
        let msg = gBR.api_win_rank;
        if(gBR.api_get_flag[1] == 1){
            msg += "(" + gBR.api_get_ship.api_ship_name + ")";
        }
        if(gBR.api_get_eventflag == 1){
            msg += "(" + gBR.api_get_eventship.api_ship_name + ")";
        }
        UpdateSortieLog(gmapID + msg);
    }
    if(gMR.api_enemy.api_enemy_id != "-"){
        calcAQuestLog(0);
        if(gMR.api_event_id == 5){
            calcAQuestLog(1);
            if((gBR.api_win_rank == "S")||
               (gBR.api_win_rank == "A")||
               (gBR.api_win_rank == "B")){
                   calcAQuestLog(2);
               }
        }
        if(gBR.api_win_rank == "S"){
            calcAQuestLog(3);
        }
    }
}catch(e){
    UpdateSortieLog(e);
}
}

function UpdateBattleLog(){
try{
    let dispsortieenemyset = hw_Branch.getBoolPref("dispsortieenemyset");
    let tset = {};
    let fset = GetEnemySet(KclInfo.gMapRequest.api_enemy.api_enemy_id);
    tset["eset_num"] = KclInfo.gMapRequest.api_enemy.api_enemy_id;
    tset["eset_list"] = [];
        let gmapID = getBStr("ENEMYSET") + "[" + KclInfo.gMapRequest.api_enemy.api_enemy_id + "]";
        let enemytaiku = 0;
        let qset = "";
        for(let i in KclInfo.gBattle.api_ship_ke){
            if(KclInfo.gBattle.api_ship_ke[i] > 0){
                let eShip = SearchMasterShipByID(KclInfo.gBattle.api_ship_ke[i]);
                if(qset.length > 0){qset += "/"}
                qset += eShip.api_name;
                if((eShip.api_yomi != "-") && (eShip.api_sortno == 0)){
                    qset += eShip.api_yomi;
                }
                
                for(let sm in KclInfo.gBattle.api_eSlot[+i - 1]){
                    if(KclInfo.gBattle.api_eSlot[+i - 1][sm] > 0){
                        let smkey = SearchMasterItemObj(KclInfo.gBattle.api_eSlot[+i - 1][sm]);
                        if((smkey.api_type[2] == "6") ||
                           (smkey.api_type[2] == "7") ||
                           (smkey.api_type[2] == "8") ||
                           (smkey.api_type[2] == "11")){
                            enemytaiku += (parseInt(Math.sqrt(+eShip.api_maxeq[sm]) * +smkey.api_tyku));
                        }
                    }
                }
                tset["eset_list"].push(KclInfo.gBattle.api_ship_ke[i]);
            }
        }
        qset += "(" + enemytaiku + ")";
        tset["eset_taiku"] = enemytaiku;
    let wset = GetEnemySet(KclInfo.gMapRequest.api_enemy.api_enemy_id);

    if(dispsortieenemyset && ((JSON.stringify(tset) != JSON.stringify(fset))||(KclInfo.gMapRequest.api_enemy.api_enemy_id == "-"))){
        UpdateSortieLog(gmapID + qset);
    }
        if(KclInfo.gMapRequest.api_enemy.api_enemy_id != "-"){
            SetEnemySet(tset);
        }
}catch(e){
    UpdateSortieLog(e);
}
}

function SearchEnemySet(num){
try{
    let dispsortieenemyset = hw_Branch.getBoolPref("dispsortieenemyset");
    let tstr = "";
    if(dispsortieenemyset){
        let eset = GetEnemySet(num);
        if(typeof eset.eset_num !== "undefined"){
            for(let j in eset.eset_list){
                if(eset.eset_list[j]>0){
                    eShip = SearchMasterShipByID(eset.eset_list[j]);
                    if(tstr.length > 0){tstr += "/"}
                    tstr += eShip.api_name;
                    if((KclInfo.gMapRequest.api_enemy.api_enemy_id != "-") && (eShip.api_yomi != "-")){
                        tstr += eShip.api_yomi;
                    }
                }
            }
            let enemytaiku = eset.eset_taiku;
            if(typeof enemytaiku === "undefined"){
                enemytaiku = "?";
            }
            tstr += "(" + enemytaiku + ")";
        }
    }
    return tstr;
}catch(e){
    UpdateSortieLog(e);
}
}

function GetEnemySet(num){
//debugprint("GetEnemySet:" + num);
    for(let i in eData.edata){
        if(eData.edata[i].eset_num == num){
            return eData.edata[i];
        }
    }
    return {};
}

function SetEnemySet(tObj){
    for(let i in eData.edata){
        if(eData.edata[i].eset_num == tObj.eset_num){
            if(JSON.stringify(eData.edata[i]) != JSON.stringify(tObj)){
                eData.edata[i] = tObj;
                setKclEnemySetsPref();
            }
            return "";
        }
    }
    eData.edata.push(tObj);
    eData.edata.sort(function(a, b){return a.eset_num - b.eset_num;});
    setKclEnemySetsPref();
    return "";
}

function calcAQuestLog(num){
try{
    for(let i in gQuestTreeList){
        if(gQuestTreeList[i].api_no == 214){
            let qdata = hw_Branch.getCharPref("questlog");
            let qlog = qdata.split(",");
            let tDate = new Date();
            let aDate = new Date("2014/01/06 05:00:00");
            let tWeek = parseInt((tDate.getTime() - aDate.getTime())/(1000 * 60 * 60 * 24 * 7));
            if(qlog[4] != tWeek){
                qlog[0] = 0;
                qlog[1] = 0;
                qlog[2] = 0;
                qlog[3] = 0;
                qlog[4] = tWeek;
            }
            if(gQuestTreeList[i].api_state == 2){
                if(num < 4){
                    qlog[num] = +qlog[num] + 1;
                }
            }
            qdata = qlog.join(",");
            hw_Branch.setCharPref("questlog", qdata);
        }
    }
}catch(e){
    UpdateSortieLog(e);
}
}

function UpdateMapInfoLog(rdata){
    for(let i in KclInfo.gMapInfo){
        if((+KclInfo.gMapInfo[+i].api_maparea_id == +KclInfo.gMapRequest.api_maparea_id)
         && (+KclInfo.gMapInfo[+i].api_no == +KclInfo.gMapRequest.api_mapinfo_no)){
//debugprint(JSON.stringify(KclInfo.gMapRequest))
            let msg = "[" + KclInfo.gMapInfo[+i].api_maparea_id + "-" + KclInfo.gMapRequest.api_mapinfo_no + "]" + KclInfo.gMapInfo[+i].api_name;
            let tkey = KclInfo.gMapRequest.api_eventmap;
            if(typeof tkey !== "undefined"){
                msg += "(" + KclInfo.gMapInfo[+i].api_eventmap.api_now_maphp + "/" + KclInfo.gMapInfo[+i].api_eventmap.api_max_maphp + ")";
            }
            tkey = KclInfo.gMapInfo[+i].api_exboss_flag;
            if(tkey == 1){
                msg += "<" + KclInfo.gMapInfo[+i].api_defeat_count + "/" + KclInfo.gMapInfo[+i].api_required_defeat_count + ">";            }
            msg += " (" + getFleetNames(+rdata.api_deck_id - 1) + ")";
            UpdateSortieLog(msg);
            break;
        }
    }
}

function getFleetNames(FltNo){
    let str = "";
    for(let i in KclInfo.gMemberFleet[FltNo].api_ship){
        if(KclInfo.gMemberFleet[FltNo].api_ship[i] > 0){
            let memShip = SearchMemberShip(KclInfo.gMemberFleet[FltNo].api_ship[i]);
            let msShip = SearchMasterShip(KclInfo.gMemberFleet[FltNo].api_ship[i]);
            if(str.length > 0){str += "/"}
            str += msShip.api_name + "(" + memShip.api_lv + ")";
        }
    }
//debugprint("getNames:" + KclInfo.gMemberFleet[FltNo].api_combined_flag);
    if(KclInfo.gMemberFleet[FltNo].api_combined_flag != 0){
        for(let i in KclInfo.gMemberFleet[FltNo + 1].api_ship){
            if(KclInfo.gMemberFleet[FltNo + 1].api_ship[i] > 0){
                let memShip = SearchMemberShip(KclInfo.gMemberFleet[FltNo + 1].api_ship[i]);
                let msShip = SearchMasterShip(KclInfo.gMemberFleet[FltNo + 1].api_ship[i]);
                if(str.length > 0){str += "/"}
                str += msShip.api_name + "(" + memShip.api_lv + ")";
            }
        }
    }

    return str;
}

function UpdateProgressLog(){
    let gMR = KclInfo.gMapRequest;
    let gEnemy = gMR.api_enemy;
    let gHappen = gMR.api_happening;
    let gItemGet = gMR.api_itemget;
    let gmapID = gMR.Direction 
               + gMR.api_maparea_id + "-" 
               + gMR.api_mapinfo_no + "-" 
               + gMR.api_no + "("
               + gMR.api_next + ")["
               + gMR.api_event_id + "]";
    let msg = "";
    if(typeof gEnemy !== "undefined"){
        if(gMR.api_event_id == 5){
            msg = getBStr("ENEMYBOSS");
        } else if(gMR.api_event_id == 4 && gMR.api_next == 0){
            msg = getBStr("ENEMYOTHER");
        } else {
            msg = getBStr("ENEMY");
        }
        msg += gEnemy.api_result_str + ":" + gEnemy.api_enemy_id + " " + SearchEnemySet(gEnemy.api_enemy_id);
    }else if(typeof gHappen !== "undefined"){
        msg = getBStr("HAPPENING") + getBStr("MATERIAL" + gHappen.api_mst_id) + ":" + gHappen.api_count;
    }else if(typeof gItemGet !== "undefined"){
        msg = getBStr("ITEMGET") + getBStr("MATERIAL" + gItemGet.api_id) + ":" + gItemGet.api_getcount;
    }
    UpdateSortieLog(gmapID + msg);
}

function GetDateTime(){
try{
    let dispsortietime = hw_Branch.getBoolPref("dispsortietime");

    if(dispsortietime){
        let tDate = new Date();
        let tStr = tDate.getFullYear() + "/" + ("0" + (tDate.getMonth() + 1)).slice(-2) + "/" + ("0" + tDate.getDate()).slice(-2)
            tStr = ("0" + tDate.getHours()).slice(-2) + ":" + ("0" + tDate.getMinutes()).slice(-2) + ":" + ("0" + tDate.getSeconds()).slice(-2) + " ";
        return tStr;
    }else{
        return "";
    }
}catch(e){
    UpdateSortieLog(e);
    throw e;
}
}

function UpdateSortieLog(str){
try{
    let logbuf = 42000;
    let aLog = dID("sortielog");
    if(aLog.value.length > logbuf){
        aLog.value = aLog.value.slice(-(logbuf - 4000));
    }
    if(aLog.value.length > 0){
        aLog.value += "\n";
    }
    aLog.value += GetDateTime() + str;
    aLog.inputField.scrollTop = aLog.inputField.scrollHeight

    let gLogFile = hw_Branch.getComplexValue("logfile", Ci.nsISupportsString).data;
    if(gLogFile != ""){
        writeToFile(gLogFile, GetDateTime() + str + "\r\n");
    }
}catch(e){
    debugprint(e);
}
}

function UpdateBaseInfo(){
    dID("shipcountvalue").value = "[" + KclInfo.gMemberShip.length + "/" + KclInfo.gMemberBasic.api_max_chara + "]";
    dID("equipmentcountvalue").value = "[" + KclInfo.gMemberItem.length + "/" + KclInfo.gMemberBasic.api_max_slotitem + "]";
if(KclInfo.gMaterial instanceof Array){
    dID("materials").value = 
              KclInfo.gMaterial[0].api_value + "/" 
            + KclInfo.gMaterial[1].api_value + "/" 
            + KclInfo.gMaterial[2].api_value + "/" 
            + KclInfo.gMaterial[3].api_value + ":[" 
            + KclInfo.gMaterial[4].api_value + "/" 
            + KclInfo.gMaterial[5].api_value + "/" 
            + KclInfo.gMaterial[6].api_value + "/" 
            + KclInfo.gMaterial[7].api_value + "]" ;
}
}

function UpdateStatusBarMode(){
try{
    let StBM = StatusBarMode;

    let dispexped = hw_Branch.getBoolPref("dispexped");
    let dispndock = hw_Branch.getBoolPref("dispndock");
    let dispkdock = hw_Branch.getBoolPref("dispkdock");

    StBM++;
    StBM = StBM % 3;
    if(StBM == 0){
        if(dispexped){
        }else{
            if(dispndock){       StBM = 1;
            }else if(dispkdock){ StBM = 2;
            }else{               StBM = 3;
            }
        }
    }else if(StBM == 1){
        if(dispndock){
        }else{
            if(dispkdock){       StBM = 2;
            }else if(dispexped){ StBM = 0;
            }else{               StBM = 3;
            }
        }
    }else if(StBM == 2){
        if(dispkdock){
        }else{
            if(dispexped){       StBM = 0;
            }else if(dispndock){ StBM = 1;
            }else{               StBM = 3;
            }
        }
    }else{
        StBM = 3;
    }
    StatusBarMode = StBM;
    clearInterval(StatusBarTimer2);
    StatusBarTimer2 = setInterval(function(){UpdateStatusBarMode();}, 5000)
}catch(e){
    UpdateSortieLog(e);
}

}

function UpdateStatusBar(){
    let dispkdockdetail = hw_Branch.getBoolPref("dispkdockdetail");

    let dt = new Date();
    let kdockdetail = "";
    dID("fleetstatus").label = "-";
    dID("fleet1comm").label = "-";
    dID("fleet2comm").label = "-";
    dID("fleet3comm").label = "-";
    dID("fleet4comm").label = "-";
    if(StatusBarMode == 0){
        dID("fleetstatus").label = getBStr("EXPEDITION");
        for(let i in KclInfo.gMemberFleet){
            if(KclInfo.gMemberFleet[+i].api_mission[0] == 1){
                let remaintime = KclInfo.gMemberFleet[+i].api_mission[2] - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60 * 60 * 1000));
                    let tMinute = ("0" + parseInt((remaintime % (60 * 60 * 1000)) / (60 * 1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60 * 1000)) / (1000))).slice(-2);
                    dID("fleet" + (+i + 1) + "comm").label = tHour + ":" + tMinute + ":" + tSecond;
                }else{
                    dID("fleet" + (+i + 1) + "comm").label = getBStr("RETURNED");
                }
            }else if(KclInfo.gMemberFleet[+i].api_mission[0] == 2){
                dID("fleet" + (+i + 1) + "comm").label = getBStr("RETURNED");
            }else{
                dID("fleet" + (+i + 1) + "comm").label = getBStr("WAITING");
            }
        }
    }else if(StatusBarMode == 1){
        dID("fleetstatus").label = getBStr("NDOCK");
        for(let i in KclInfo.gMemberNDock){
            if(KclInfo.gMemberNDock[+i].api_state == 1){
                let remaintime = KclInfo.gMemberNDock[+i].api_complete_time - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60 * 60 * 1000));
                    let tMinute = ("0" + parseInt((remaintime % (60 * 60 * 1000)) / (60 * 1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60 * 1000)) / (1000))).slice(-2);
                    dID("fleet" + (+i + 1) + "comm").label = tHour + ":" + tMinute + ":" + tSecond;
                }else{
                    dID("fleet" + (+i + 1) + "comm").label = getBStr("COMPLETED");
                }
            }else if(KclInfo.gMemberNDock[+i].api_state == 0){
                dID("fleet" + (+i + 1) + "comm").label = getBStr("NOUSE");
            }else{
                dID("fleet" + (+i + 1) + "comm").label = getBStr("CLOSED");
            }
        }
    }else if(StatusBarMode == 2){
        dID("fleetstatus").label = getBStr("KDOCK");
        for(let i in KclInfo.gMemberKDock){
            if(dispkdockdetail && (KclInfo.gMemberKDock[+i].api_created_ship_id > 0)){
                kdockdetail = " - " + SearchMasterShipByID(KclInfo.gMemberKDock[+i].api_created_ship_id).api_name;
            }else{
                kdockdetail = "";
            }
            if(KclInfo.gMemberKDock[+i].api_state == 2){
                let remaintime = KclInfo.gMemberKDock[+i].api_complete_time - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60 * 60 * 1000));
                    let tMinute = ("0" + parseInt((remaintime % (60 * 60 * 1000)) / (60 * 1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60 * 1000)) / (1000))).slice(-2);
                    dID("fleet" + (+i + 1) + "comm").label = tHour + ":" + tMinute + ":" + tSecond + kdockdetail;
                }else{
                    dID("fleet" + (+i + 1) + "comm").label = getBStr("KCOMPLETED") + kdockdetail;
                }
            }else if(KclInfo.gMemberKDock[+i].api_state == 0){
                dID("fleet" + (+i + 1) + "comm").label = getBStr("NOUSE");
            }else if(KclInfo.gMemberKDock[+i].api_state == 3){
                dID("fleet" + (+i + 1) +"comm").label = getBStr("KCOMPLETED") + kdockdetail;
            }else{
                dID("fleet" + (+i + 1) + "comm").label = getBStr("CLOSED");
            }
        }
    }else{
    dID("fleetstatus").label = "-";
    dID("fleet1comm").label = "-";
    dID("fleet2comm").label = "-";
    dID("fleet3comm").label = "-";
    dID("fleet4comm").label = "-";
    };
}

function UpdateFleetList(){
    for(let i in KclInfo.gMemberFleet){
        dID("fleet" + (+i + 1) + "name").value = KclInfo.gMemberFleet[+i].api_name;
        let lvsum = 0;
        let sakusum = 0;
        let sakutei = 0;
        let sakuden = 0;
        let taikusum = 0;

        for(let j in KclInfo.gMemberFleet[+i].api_ship){
            let mShip = KclInfo.gMemberFleet[+i].api_ship[+j];
            if(mShip > 0){
                let memShip = SearchMemberShip(mShip);
                let msShip = SearchMasterShip(mShip);
                let fsNO = "fleet" + (+i + 1) + "ship" + (+j + 1);
                dID(fsNO + "level").value = memShip.api_lv;
                dID(fsNO + "cond").value = memShip.api_cond;
                dID(fsNO + "name").value = msShip.api_name;
                let num = "";
                if((+msShip.api_houg[1] - +msShip.api_houg[0]) > +memShip.api_kyouka[0]){
                    num = "*";
                }else{
                    num = "";
                }
                dID(fsNO + "powup1").value = num + memShip.api_karyoku[0];
                if((+msShip.api_raig[1] - +msShip.api_raig[0]) > +memShip.api_kyouka[1]){
                    num = "*";
                }else{
                    num = "";
                }
                dID(fsNO + "powup2").value = num + memShip.api_raisou[0];
                if((+msShip.api_tyku[1] - +msShip.api_tyku[0]) > +memShip.api_kyouka[2]){
                    num = "*";
                }else{
                    num = "";
                }
                dID(fsNO + "powup3").value = num + memShip.api_taiku[0];
                if((+msShip.api_souk[1] - +msShip.api_souk[0]) > +memShip.api_kyouka[3]){
                    num = "*";
                }else{
                    num = "";
                }
                dID(fsNO + "powup4").value =  num + memShip.api_soukou[0];
                if((+msShip.api_luck[1] - +msShip.api_luck[0]) > +memShip.api_kyouka[4]){
                    num = "*";
                }else{
                    num ="";
                }
                dID(fsNO + "powup5").value = num + memShip.api_lucky[0];
                dID(fsNO + "saku").value = memShip.api_sakuteki[0];
                dID(fsNO + "taisen").value = memShip.api_taisen[0];
                dID(fsNO + "kaihi").value = memShip.api_kaihi[0];

                if((+memShip.api_fuel < +msShip.api_fuel_max) || (+memShip.api_bull < +msShip.api_bull_max)){
                    dID(fsNO + "supply").value = "*";
                }else{
                    dID(fsNO + "supply").value = "";
                }
                dID(fsNO + "hp").value = "[" + memShip.api_nowhp + "/" + memShip.api_maxhp + "]";
                lvsum += +memShip.api_lv;
                sakusum += +memShip.api_sakuteki[0];
                for(let sm in memShip.api_slot){
                    if(+memShip.api_slot[sm] > 0){
                        let smkey = SearchMemberItemObj(+memShip.api_slot[sm]);
                        if(typeof smkey !== "undefined"){
                            if((smkey.api_type[2] == "6") ||
                               (smkey.api_type[2] == "7") ||
                               (smkey.api_type[2] == "8") ||
                               (smkey.api_type[2] == "11")){
                                taikusum += parseInt(Math.sqrt(+memShip.api_onslot[sm]) * +smkey.api_tyku);
                            }
                            if((smkey.api_type[2] == "9") ||
                               (smkey.api_type[2] == "10") ||
                               (smkey.api_type[2] == "11")){
                                if(+memShip.api_onslot[sm] > 0){
                                    sakutei += +smkey.api_saku;
                                }
                            }
                            if((smkey.api_type[2] == "12") ||
                               (smkey.api_type[2] == "13")){
                                    sakuden += +smkey.api_saku;
                            }
                        }
                    }
                }
                sakusum = parseInt((sakutei * 2) + (sakuden) + Math.sqrt(sakusum - sakutei - sakuden));
            }else{
                let fsNO = "fleet" + (+i + 1) + "ship" + (+j + 1);
                dID(fsNO + "level").value = ""
                dID(fsNO + "cond").value = ""
                dID(fsNO + "saku").value = ""
                dID(fsNO + "name").value = ""
                dID(fsNO + "powup1").value = ""
                dID(fsNO + "powup2").value = ""
                dID(fsNO + "powup3").value = ""
                dID(fsNO + "powup4").value = ""
                dID(fsNO + "powup5").value = ""
                dID(fsNO + "hp").value = ""
                dID(fsNO + "supply").value = ""
                dID(fsNO + "taisen").value = ""
                dID(fsNO + "kaihi").value = ""
            }
        }
        dID("fleet" + (+i + 1) + "lv").value = lvsum;
        dID("fleet" + (+i + 1) + "saku").value = sakusum;
        dID("fleet" + (+i + 1) + "taiku").value = taikusum;
    }

}

var gQuestTreeList = [];
var gQuestTreeView = null;

function UpdateQuestList(){
    gQuestTreeList.length = KclInfo.gQuestList.api_count;
    for(let i = 0; i < KclInfo.gQuestList.api_count; i++){
        if(typeof gQuestTreeList[i] === "undefined"){
            gQuestTreeList[i] = {api_no:'*', api_title:'*', api_detail:'*', api_progress_flag:'*', api_state:'*'};
        }
    }

    if(KclInfo.gQuestList.api_record){
        for(let i in gQuestTreeList){
            if(gQuestTreeList[i].api_title.slice(0, 1) != "*"){
                gQuestTreeList[i].api_title = "*" + gQuestTreeList[i].api_title;
            }
        }
    }
    for(let i in KclInfo.gQuestList.api_list){
        let j = +KclInfo.gQuestList.api_disp_page - 1;
        if(typeof KclInfo.gQuestList.api_list[+i].api_title !== "undefined"){
            gQuestTreeList[(j * 5) + +i] = KclInfo.gQuestList.api_list[+i];
        }
    }
}

function initQuestTree(){
    gQuestTreeView = new QuestTreeView(gQuestTreeList);
    dID("QuestTree").view = gQuestTreeView;
}

function QuestTreeView(aData){
    this._data = aData;
}

QuestTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount(){
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties){},
    getCellProperties: function(row, col, properties){},
    getColumnProperties: function(col, properties){},
    isContainer: function(index){return false;},
    isContainerOpen: function(index){return false;},
    isContainerEmpty: function(index){return false;},
    isSeparator: function(index){
        return this._data[index] == null;
    },
    isSorted: function(){return false;},
    canDrop: function(targetIndex, orientation, dataTransfer){return false;},
    drop: function(targetIndex, orientation, dataTransfer){},
    getParentIndex: function(rowIndex){return -1;},
    hasNextSibling: function(rowIndex, afterIndex){return false;},
    getLevel: function(index){return 0;},
    getImageSrc: function(row, col){},
    getProgressMode: function(row, col){},
    getCellValue: function(row, col){},
    getCellText: function(row, col){
        switch (col.id){
            case "quest.api_no" : return gQuestTreeList[row].api_no;
            case "quest.api_title" : return gQuestTreeList[row].api_title;
            case "quest.api_progress_flag" : 
                switch (gQuestTreeList[row].api_progress_flag){
                    case 1  : return getBStr("QUEST50");
                    case 2  : return getBStr("QUEST80");
                    default : return "";
                };
            case "quest.api_state" : 
                switch (gQuestTreeList[row].api_state){
                    case 1  : return getBStr("QUESTNONEXEC");
                    case 2  : return getBStr("QUESTEXEC");
                    case 3  : return getBStr("QUESTCOMP");
                    default : return "";
                }
            default : return 0;
        }
    },
    setTree: function(tree){
        if(tree){
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index){},
    cycleHeader: function(col){},
    selectionChanged: function(){},
    cycleCell: function(row, col){},
    isEditable: function(row, col){return false;},
    isSelectable: function(row, col){},
    setCellValue: function(row, col, value){},
    setCellText: function(row, col, value){},
    performAction: function(action){},
    performActionOnRow: function(action, row){},
    performActionOnCell: function(action, row, col){},
};

function QuestDetailContext(tObjs){
try{
    let tIdx = (dID("QuestTree")).currentIndex;
    tObjs.value = gQuestTreeList[tIdx].api_detail + "\n" 
                + gQuestTreeList[tIdx].api_get_material.join("/");
    calcAQuestLog(4);
    if(gQuestTreeList[tIdx].api_no == 214){
        let qdata = hw_Branch.getCharPref("questlog");
        let qlog = qdata.split(",");
        tObjs.value = tObjs.value + "[" + qlog[0] + "/" + qlog[1] + "/" + qlog[2] + "/" + qlog[3] + "]";
    }

}catch(e){
    UpdateSortieLog(e);
}
}

function SearchMemberShip(member_ship_id){
    if(member_ship_id <= 0){return JSON.parse(defBlankMemberShip);}
    try{
        for(let i in KclInfo.gMemberShip){
            if(KclInfo.gMemberShip[i].api_id == member_ship_id){
                return KclInfo.gMemberShip[i];
            }
        }
    }catch(e){
    throw e;
    }
    return JSON.parse(defBlankMemberShip);
}

function SearchMasterShip(member_ship_id){
    if(member_ship_id <= 0){return JSON.parse(defBlankMasterShip);}

    try{
        return SearchMasterShipByID(SearchMemberShip(member_ship_id).api_ship_id);
    }catch(e){
    throw e;
    }
    return JSON.parse(defBlankMasterShip);
}

function SearchMasterShipByID(master_ship_id){
    if(master_ship_id <= 0){return JSON.parse(defBlankMasterShip);}
    try{
        for(let i in KclInfo.gMasterShip){
            if(KclInfo.gMasterShip[i].api_id == master_ship_id){
                return KclInfo.gMasterShip[i];
            }
        }
    }catch(e){
    throw e;
    }
    return JSON.parse(defBlankMasterShip);
}

function SearchMemberItemObj(item_id){
    if(item_id > 0){;
        for(let i in KclInfo.gMemberItem){
            if(KclInfo.gMemberItem[i].api_id == item_id){
                return SearchMasterItemObj(KclInfo.gMemberItem[i].api_slotitem_id);
            }
        }
    }
    return JSON.parse(defBlankMasterItem);
}

function SearchMasterItemObj(item_id){
    if(item_id > 0){
        for(let i in KclInfo.gMasterItem){
            if(KclInfo.gMasterItem[i].api_id == item_id){
                return KclInfo.gMasterItem[i];
            }
        }
    }
    return JSON.parse(defBlankMasterItem);
}

function CopyToClipboard(str){
    if(str.length <= 0) return;
    let gClipboardHelper = Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);  
    gClipboardHelper.copyString(str);
}

var gShipTreeView = null;
var gShipTreeList2 = [];

function initShipTree(){
    UpdateFleetList();
    let tree = dID("ShipTree")
    let fIdx = tree.treeBoxObject.getFirstVisibleRow();
    gShipTreeList2 = [];
    for(let i in KclInfo.gMemberShip){
        msShip = SearchMasterShip(KclInfo.gMemberShip[i].api_id);
        let tObj = {
            "api_id":KclInfo.gMemberShip[i].api_id,
            "api_name":msShip.api_name,
            "api_stype":msShip.api_stype,
            "api_lv":KclInfo.gMemberShip[i].api_lv,
            "api_cond":KclInfo.gMemberShip[i].api_cond,
            "api_sakuteki":KclInfo.gMemberShip[i].api_sakuteki[0],
            "api_houg":msShip.api_houg[1] - msShip.api_houg[0] - KclInfo.gMemberShip[i].api_kyouka[0],
            "api_raig":msShip.api_raig[1] - msShip.api_raig[0] - KclInfo.gMemberShip[i].api_kyouka[1],
            "api_tyku":msShip.api_tyku[1] - msShip.api_tyku[0] - KclInfo.gMemberShip[i].api_kyouka[2],
            "api_souk":msShip.api_souk[1] - msShip.api_souk[0] - KclInfo.gMemberShip[i].api_kyouka[3],
            "api_luck":msShip.api_luck[1] - msShip.api_luck[0] - KclInfo.gMemberShip[i].api_kyouka[4],
            "api_ndock_time":KclInfo.gMemberShip[i].api_ndock_time,
            "api_slot1":SearchMemberItemObj(KclInfo.gMemberShip[i].api_slot[0]).api_id,
            "api_slot2":SearchMemberItemObj(KclInfo.gMemberShip[i].api_slot[1]).api_id,
            "api_slot3":SearchMemberItemObj(KclInfo.gMemberShip[i].api_slot[2]).api_id,
            "api_slot4":SearchMemberItemObj(KclInfo.gMemberShip[i].api_slot[3]).api_id,
            "api_slot5":SearchMemberItemObj(KclInfo.gMemberShip[i].api_slot[4]).api_id,
            "api_index":i,
            "api_sortno":msShip.api_sortno
            }
        gShipTreeList2.push(tObj);
    }
    gShipTreeView = new ShipTreeView(KclInfo.gMemberShip);
    for(let i = 0; i < tree.columns.length; i++){
//debugprint(i);
        sOrder = tree.columns.getColumnAt(i).element.getAttribute("sortDirection");
        
        sID = tree.columns.getColumnAt(i).id;
        
        let odr = 0;
        if(sOrder == "ascending"){
            odr = 1;
        } else if(sOrder == "descending"){
            odr = -1;
        };
        if(odr != 0){
            gShipTreeList2.sort(
                function(a, b){
                    if(a[sID] == b[sID]){
                        if(a.api_stype == b.api_stype){
                            return (a.api_sortno - b.api_sortno);
                        }else{
                            return (a.api_stype - b.api_stype);
                        } 
                    }else{
                        return (a[sID] - b[sID]) * odr;
                    }
                }
            );

        }
    }

    tree.view = gShipTreeView;
    tree.treeBoxObject.scrollToRow(fIdx);
    tree.treeBoxObject.invalidate();
}

function destroyShipTree(){
    dID("ShipTree").view = null;
}

function ShipTreeView(aData){
    this._data = aData;
}

ShipTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount(){
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties){
        let rflt = gShipTreeList2[index].api_id;
        let aserv = Cc["@mozilla.org/atom-service;1"].getService(Ci.nsIAtomService);

        for(let i in KclInfo.gMemberFleet){
            if(KclInfo.gMemberFleet[i].api_mission[0] == 1){
                for(let j in KclInfo.gMemberFleet[i].api_ship){
                    if(KclInfo.gMemberFleet[i].api_ship[j] == rflt){
                        if(typeof properties === "undefined"){
                            return aserv.getAtom("fleets");
                        }else{
                            properties.AppendElement(aserv.getAtom("fleets"));
                            return properties;
                        }
                    }
                }
            }
        }
        let memShip = SearchMemberShip(rflt);
        let msShip = SearchMasterShip(rflt);
        if((memShip.api_fuel != msShip.api_fuel_max) || (memShip.api_bull != msShip.api_bull_max)){
            if(typeof properties === "undefined"){
                return aserv.getAtom("supply");
            }else{
                properties.AppendElement(aserv.getAtom("supply"));
                return properties;
            }
        }
        return properties;
    },
    getCellProperties: function(row, col, properties){},
    getColumnProperties: function(col, properties){},
    isContainer: function(index){return false;},
    isContainerOpen: function(index){return false;},
    isContainerEmpty: function(index){return false;},
    isSeparator: function(index){
        return this._data[index] == null;
    },
    isSorted: function(){return false;},
    canDrop: function(targetIndex, orientation, dataTransfer){return false;},
    drop: function(targetIndex, orientation, dataTransfer){},
    getParentIndex: function(rowIndex){return -1;},
    hasNextSibling: function(rowIndex, afterIndex){return false;},
    getLevel: function(index){return 0;},
    getImageSrc: function(row, col){},
    getProgressMode: function(row, col){},
    getCellValue: function(row, col){},
    getCellText: function(row, col){
        switch (col.id){
            case "api_id" : return +gShipTreeList2[row].api_id;
            case "api_name" : return gShipTreeList2[row].api_name;
            case "api_stype" : return +gShipTreeList2[row].api_stype;
            case "api_lv" : return +gShipTreeList2[row].api_lv;
            case "api_cond" : return +gShipTreeList2[row].api_cond;
            case "api_sakuteki" : return +gShipTreeList2[row].api_sakuteki;
            case "api_houg" : return +gShipTreeList2[row].api_houg;
            case "api_raig" : return +gShipTreeList2[row].api_raig;
            case "api_tyku" : return +gShipTreeList2[row].api_tyku;
            case "api_souk" : return +gShipTreeList2[row].api_souk;
            case "api_luck" : return +gShipTreeList2[row].api_luck;
            case "api_ndock_time" : let rtime = gShipTreeList2[row].api_ndock_time;
                                    if(rtime == 0){
                                        return "";
                                    } else {
                                        rtime = parseInt(rtime / 1000);
                                        let rsec = rtime % 60;
                                        rtime = (rtime - rsec)/60;
                                        let rmin = rtime %60;
                                        rtime = (rtime - rmin)/60;
                                        return ("00" + rtime).slice(-2) + ":" + ("00" + rmin).slice(-2) + ":" + ("00" + rsec).slice(-2);
                                    }
            case "api_slot1" : return SearchMasterItemObj(gShipTreeList2[row].api_slot1).api_name;
            case "api_slot2" : return SearchMasterItemObj(gShipTreeList2[row].api_slot2).api_name;
            case "api_slot3" : return SearchMasterItemObj(gShipTreeList2[row].api_slot3).api_name;
            case "api_slot4" : return SearchMasterItemObj(gShipTreeList2[row].api_slot4).api_name;
            case "api_slot5" : return SearchMasterItemObj(gShipTreeList2[row].api_slot5).api_name;
            default : return 0;
        }
    },
    setTree: function(tree){
        if(tree){
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index){},
    cycleHeader: function(col){
        let sOrder = col.element.getAttribute("sortDirection");
        for(let i in col.columns){
            col.columns.getColumnAt(i).element.setAttribute("sortDirection", "natural");
        };
        let odr = 0;
        if(sOrder == "ascending"){
            odr = -1;
            sOrder = "descending" ;
        } else {
            odr = 1;
            sOrder = "ascending"  ;
        };
            gShipTreeList2.sort(
                function(a, b){
                    if(a[col.id] == b[col.id]){
                        if(a.api_stype == b.api_stype){
                            return (a.api_sortno - b.api_sortno);
                        }else{
                            return (a.api_stype - b.api_stype);
                        } 
                    }else{
                        return (a[col.id] - b[col.id]) * odr;
                    }
                }
            );

        col.element.setAttribute("sortDirection", sOrder);
        this._treeBoxObject.invalidate();
    },
    selectionChanged: function(){},
    cycleCell: function(row, col){},
    isEditable: function(row, col){return false;},
    isSelectable: function(row, col){},
    setCellValue: function(row, col, value){},
    setCellText: function(row, col, value){},
    performAction: function(action){},
    performActionOnRow: function(action, row){},
    performActionOnCell: function(action, row, col){},
};

var gItemList = [];


function UpdateItemList(){
    let gItemEquipList = [];
    for(let i in KclInfo.gMemberShip){
        let tSlot = KclInfo.gMemberShip[i].api_slot;
        if(tSlot[0] > 0){gItemEquipList[+tSlot[0]] = i;}
        if(tSlot[1] > 0){gItemEquipList[+tSlot[1]] = i;}
        if(tSlot[2] > 0){gItemEquipList[+tSlot[2]] = i;}
        if(tSlot[3] > 0){gItemEquipList[+tSlot[3]] = i;}
    }

    gItemList = [];
    for(let i in KclInfo.gMemberItem){
        let ItemID = KclInfo.gMemberItem[i].api_slotitem_id;
        let ItemListID = gItemList[ItemID];
        if(typeof ItemListID === "undefined"){
            gItemList[ItemID] = [KclInfo.gMemberItem[i].api_slotitem_id, SearchMasterItemObj(ItemID).api_name, 0, 0, ""];
            ItemListID = gItemList[ItemID];
        }
        let ItemEquipID = gItemEquipList[+KclInfo.gMemberItem[i].api_id];
        if(typeof ItemEquipID !== "undefined"){
            ItemListID[2] += 1;
            ItemListID[4] += "," + ItemEquipID;
        }

        ItemListID[3] += 1;
    }

    let reList = [];
    for(let j in gItemList){
       let nAry = [
           gItemList[j][0],
           gItemList[j][1],
           gItemList[j][2],
           gItemList[j][3],
           gItemList[j][4]
           ]
       reList.push(nAry);
    }
    gItemList = [];
    gItemList = reList;
}

function EquipedShipsList(tObjs){
    let eList = "";
    tObjs.value = "testupdate." + (dID("ItemTree")).currentIndex;
    let tItem = (dID("ItemTree")).currentIndex;
    tItem = gItemList[tItem][4].split(",");
    tItem.sort();
    for(let i in tItem){
        let tShip = KclInfo.gMemberShip[tItem[i]];
        if(typeof tShip !== "undefined"){
            eList += "\n" + tShip.api_id + ":" + SearchMasterShip(tShip.api_id).api_name + "(Lv" + tShip.api_lv + ")";
        }
    }
    tObjs.value = eList.trim();
}

function ShipDetailContext(tObjs, event){
    let fleet = +(tObjs.slice(5, 6)) - 1;
    let shipid = +(tObjs.slice(10, 11)) - 1;
    if(KclInfo.gMemberFleet[fleet].api_ship[shipid] != -1){
        let memShip = SearchMemberShip(KclInfo.gMemberFleet[fleet].api_ship[shipid]);
        let msShip = SearchMasterShip(KclInfo.gMemberFleet[fleet].api_ship[shipid]);
        dID("shipdetailname").value = msShip.api_name;
        dID("shipdetaillv").value = memShip.api_lv;
        dID("shipdetailstatus").value = "[" + memShip.api_nowhp + "/" + memShip.api_maxhp + "]";
        dID("shipdetailexp").value = "[" + +memShip.api_exp[0] + "/" + (+memShip.api_exp[1] + +memShip.api_exp[0]) + "@" + +memShip.api_exp[1] + "]";
        dID("shipdetailequip1").value = SearchMemberItemObj(memShip.api_slot[0]).api_name;
        dID("shipdetailequip2").value = SearchMemberItemObj(memShip.api_slot[1]).api_name;
        dID("shipdetailequip3").value = SearchMemberItemObj(memShip.api_slot[2]).api_name;
        dID("shipdetailequip4").value = SearchMemberItemObj(memShip.api_slot[3]).api_name;
        dID("shipdetailequip5").value = SearchMemberItemObj(memShip.api_slot[4]).api_name;
    }else{
        event.preventDefault();
    }
}


var gItemTreeView = null;

function initItemTree(){
    UpdateItemList();
    let tree = dID("ItemTree")
    let fIdx = tree.treeBoxObject.getFirstVisibleRow();

    gItemTreeView = new ItemTreeView(gItemList);
    for(let i in dID("ItemTree").columns){
        dID("ItemTree").columns.getColumnAt(i).element.setAttribute("sortDirection", "natural");
    }
    dID("ItemTree").view = gItemTreeView;

    tree.treeBoxObject.scrollToRow(fIdx);
    tree.treeBoxObject.invalidate();
}

function destroyItemTree(){
    dID("ItemTree").view = null;
}

function ItemTreeView(aData){
    this._data = aData;
}

ItemTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount(){
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties){},
    getCellProperties: function(row, col, properties){},
    getColumnProperties: function(col, properties){},
    isContainer: function(index){return false;},
    isContainerOpen: function(index){return false;},
    isContainerEmpty: function(index){return false;},
    isSeparator: function(index){
        return this._data[index] == null;
    },
    isSorted: function(){return false;},
    canDrop: function(targetIndex, orientation, dataTransfer){return false;},
    drop: function(targetIndex, orientation, dataTransfer){},
    getParentIndex: function(rowIndex){return -1;},
    hasNextSibling: function(rowIndex, afterIndex){return false;},
    getLevel: function(index){return 0;},
    getImageSrc: function(row, col){},
    getProgressMode: function(row, col){},
    getCellValue: function(row, col){},
    getCellText: function(row, col){
        switch (col.index){
            case 0 : return gItemList[row][0];
            case 1 : return gItemList[row][1];
            case 2 : return gItemList[row][2];
            case 3 : return gItemList[row][3];
            default : return 0;
        }
    },
    setTree: function(tree){
        if(tree){
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index){},
    cycleHeader: function(col){
        let sOrder = col.element.getAttribute("sortDirection");
        for(let i in col.columns){
            col.columns.getColumnAt(i).element.setAttribute("sortDirection", "natural");
        };
        let odr = 0;
        if(sOrder == "ascending"){
            odr = -1;
            sOrder = "descending" ;
        } else {
            odr = 1;
            sOrder = "ascending"  ;
        };
        gItemList.sort(
            function(a, b){
                return (a[col.index] - b[col.index]) * odr;
            }
        );
        col.element.setAttribute("sortDirection", sOrder);
        this._treeBoxObject.invalidate();
    },
    selectionChanged: function(){},
    cycleCell: function(row, col){
    },
    isEditable: function(row, col){return false;},
    isSelectable: function(row, col){},
    setCellValue: function(row, col, value){},
    setCellText: function(row, col, value){},
    performAction: function(action){},
    performActionOnRow: function(action, row){},
    performActionOnCell: function(action, row, col){},
};

function DeleteSortieLog(){
    dID("sortielog").value = "";
}

function calcBattleLog(){
try{
    let dispsortiecalcbattle = hw_Branch.getBoolPref("dispsortiecalcbattle");
    if(dispsortiecalcbattle == false){
        return "";
    }
//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];

    calcDayAttack(dmghps, KclInfo.gBattle);
    calcBattleResultLog(dmghps, nowhps, maxhps);
    return "";
}catch(e){
    UpdateSortieLog(e);
}
}


function calcMidnightBattleLog(){
try{
    let dispsortiecalcbattle = hw_Branch.getBoolPref("dispsortiecalcbattle");
    if(dispsortiecalcbattle == false){
        return "";
    }
//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];
//NightMode
    calcNightAttack(dmghps, KclInfo.gBattle.api_hougeki);
    calcBattleResultLog(dmghps, nowhps, maxhps);
    return "";
}catch(e){
    UpdateSortieLog(e);
}
}


function calcNightToDayBattleLog(){
try{
    let dispsortiecalcbattle = hw_Branch.getBoolPref("dispsortiecalcbattle");
    if(dispsortiecalcbattle == false){
        return "";
    }

//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];
//NightMode
    calcNightAttack(dmghps,KclInfo.gBattle.api_hougeki);
//dayFlag
    if(KclInfo.gBattle.api_day_flag == 1){
        calcDayAttack(dmghps, KclInfo.gBattle);
    }
    calcBattleResultLog(dmghps, nowhps, maxhps);
    return "";
}catch(e){
    UpdateSortieLog(e);
}
}

function calcDayAttack(dmghps, tObjs){
//api_stage_flag
    if(tObjs.api_stage_flag[2] == 1){
        let fdam = tObjs.api_kouku.api_stage3.api_fdam;
        for(let i in fdam){
            if(fdam[+i] != -1){
                dmghps[+i] += parseInt(fdam[+i]);
            }
        }
        let edam = tObjs.api_kouku.api_stage3.api_edam;
        for(let i in edam){
            if(edam[+i] != -1){
                dmghps[+i + 6] += parseInt(edam[+i]);
            }
        }
    }
//api_support_flag
    calcSupportAttack(dmghps, tObjs.api_support_flag, tObjs.api_support_info);
//api_opening_flag
    if(tObjs.api_opening_flag == 1){
        calcOpeningAttack(dmghps, tObjs.api_opening_atack);
    }
//api_hourai
    calcHouraiAttack(dmghps,
                     tObjs.api_hourai_flag,
                     tObjs.api_hougeki1,
                     tObjs.api_hougeki2,
                     tObjs.api_hougeki3,
                     tObjs.api_raigeki);
    return dmghps;
}

function calcSupportAttack(dmghps, tFlags, tObjs){
    if(tFlags == 1){
        UpdateSortieLog(getBStr("AIRSUPPORT"));
        for(let i = 1; i < 7; i++){
            if(tObjs.api_support_airatack.api_stage3[i] > 0){
                dmghps[i + 6] += parseInt(tObjs.api_support_airatack.api_stage3[i]);
            }
        }
    }else if(tFlags == 2){
        UpdateSortieLog(getBStr("HOURAISUPPORT"));
        for(let i = 1; i < 7; i++){
            if(tObjs.api_support_hourai.api_damage[i] > 0){
                dmghps[i + 6] += parseInt(tObjs.api_support_hourai.api_damage[i]);
            }
        }
    }
    return dmghps;
}

function calcNightAttack(dmghps, tObjs){
    for(let i in tObjs.api_df_list){
        if(tObjs.api_df_list[+i] instanceof Array){
            for(let k in tObjs.api_df_list[+i]){
                let j = +tObjs.api_df_list[+i][+k];
                if(tObjs.api_damage[+i][+k] != -1){
                    dmghps[j] += parseInt(tObjs.api_damage[+i][+k]);
                }
            }
        }
    }
    return dmghps;
}

function calcHouraiAttack(dmghps, tFlags, tObjs1, tObjs2, tObsj3, tObjs4){
    if(tFlags[0] == 1){
        for(let i in tObjs1.api_df_list){
            if(tObjs1.api_df_list[+i] instanceof Array){
                for(let k in tObjs1.api_df_list[+i]){
                    let j = +tObjs1.api_df_list[+i][+k];
                    if(tObjs1.api_damage[+i][+k] != -1){
                        dmghps[j] += parseInt(tObjs1.api_damage[+i][+k]);
                    }
                }
            }else{
                let j = parseInt(tObjs1.api_df_list[+i]);
                if(tObjs1.api_damage[+i] != -1){
                    dmghps[j] += parseInt(tObjs1.api_damage[+i]);
                }
            }
        }
    }

    if(tFlags[1] == 1){
        for(let i in tObjs2.api_df_list){
            if(tObjs2.api_df_list[+i] instanceof Array){
                for(let k in tObjs2.api_df_list[+i]){
                    let j = +tObjs2.api_df_list[+i][+k];
                    if(tObjs2.api_damage[+i][+k] != -1){
                        dmghps[j] += parseInt(tObjs2.api_damage[+i][+k]);
                    }
                }
            }else{
                let j = +tObjs2.api_df_list[+i];
                if(tObjs2.api_damage[+i] != -1){
                    dmghps[j] += parseInt(tObjs2.api_damage[+i]);
                }
            }
        }
    }

    if(tFlags[3] == 1){
        for(let i in tObjs4.api_fdam){
            if(tObjs4.api_fdam[+i] != -1){
                dmghps[+i] += parseInt(tObjs4.api_fdam[+i]);
            }
        }
        for(let i in tObjs4.api_edam){
            if(tObjs4.api_edam[+i] != -1){
                dmghps[+i + 6] += parseInt(tObjs4.api_edam[+i]);
            }
        }
    }
    return dmghps;
}

function calcOpeningAttack(dmghps, tObjs){
    for(let i in tObjs.api_fdam){
        if(tObjs.api_fdam[+i] != -1){
            dmghps[+i] += parseInt(tObjs.api_fdam[+i]);
        }
    }
    for(let i in tObjs.api_edam){
        if(tObjs.api_edam[+i] != -1){
            dmghps[+i + 6] += parseInt(tObjs.api_edam[+i]);
        }
    }
    return dmghps;
}

function calcBattleResultLog(dmghps, nowhps, maxhps){
    let fMsg = getBStr("MYFLEET");
    let eMsg = getBStr("ENEMYFLEET");
    let fRatio = [0, 0];
    let fRatio = [0, 0];
    let eRatio = [0, 0];
    let dFlag = "";
    let dList = "";

//calculate
    for(let i = 0; i < 13; i++){
        dmghps[i] = nowhps[i] - dmghps[i];
        if(dmghps[i] < 0){dmghps[i] = 0}
    }
    for(let i = 1; i < 7; i++){
        if(maxhps[i] != -1){
            fMsg += "[" + dmghps[i] + "/" + maxhps[i] + "]";
            fRatio[0] += +dmghps[i];
            fRatio[1] += +nowhps[i];
            let drt = dmghps[i] / maxhps[i];
            if(drt <= 0.25){
                dFlag = getBStr("DMGHIGHRATIO");
            }else if((drt <= 0.5) && (dFlag == "")){
                dFlag = getBStr("DMGMIDRATIO");
            }
        }
    }
    for(let i = 7; i < 13; i++){
        if(maxhps[i] != -1){
            eMsg += "[" + dmghps[i] + "/" + maxhps[i] + "]";
            eRatio[0] += +dmghps[i];
            eRatio[1] += +nowhps[i];
        }
    }
// output
    fMsg = (((fRatio[1] - fRatio[0]) / fRatio[1]) * 100).toFixed(1) + "%:" + fMsg
    eMsg = (((eRatio[1] - eRatio[0]) / eRatio[1]) * 100).toFixed(1) + "%:" + eMsg
    UpdateSortieLog(fMsg);
    UpdateSortieLog(eMsg);
    if(dFlag != ""){
        UpdateSortieLog(dFlag);
    }
//    calcBattleDetailLog(dmghps, nowhps, maxhps);
    return dmghps;
}

function calcCombinedAirBattleLog(){
//    UpdateSortieLog("undefined combined air battle.")
    let tObjs = KclInfo.gBattle;
//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];
    let nowhpsc = KclInfo.gBattle.api_nowhps_combined;
    let maxhpsc = KclInfo.gBattle.api_maxhps_combined;
    let dmghpsc = [0, 0,0,0,0,0,0 ];
try{
//api_stage_flag
    if(tObjs.api_stage_flag[2] == 1){
        let fdam = tObjs.api_kouku.api_stage3.api_fdam;
        for(let i in fdam){
            if(fdam[+i] != -1){
                dmghps[+i] += parseInt(fdam[+i]);
            }
        }
        let edam = tObjs.api_kouku.api_stage3.api_edam;
        for(let i in edam){
            if(edam[+i] != -1){
                dmghps[+i + 6] += parseInt(edam[+i]);
            }
        }

        let fdam2 = tObjs.api_kouku.api_stage3_combined.api_fdam;
        for(let i in fdam2){
            if(fdam2[+i] != -1){
                dmghpsc[+i] += parseInt(fdam2[+i]);
            }
        }

    }
//support attack
    calcSupportAttack(dmghps, tObjs.api_support_flag, tObjs.api_support_info);

//api_stage_flag2
    if(tObjs.api_stage_flag2[2] == 1){
        let fdam = tObjs.api_kouku2.api_stage3.api_fdam;
        for(let i in fdam){
            if(fdam[+i] != -1){
                dmghps[+i] += parseInt(fdam[+i]);
            }
        }

        let edam = tObjs.api_kouku2.api_stage3.api_edam;
        for(let i in edam){
            if(edam[+i] != -1){
                dmghps[+i + 6] += parseInt(edam[+i]);
            }
        }

        let fdam2 = tObjs.api_kouku2.api_stage3_combined.api_fdam;
        for(let i in fdam2){
            if(fdam2[+i] != -1){
                dmghpsc[+i] += parseInt(fdam2[+i]);
            }
        }
    calcCombinedBattleResultLog(dmghps, nowhps, maxhps, dmghpsc, nowhpsc, maxhpsc);
    }
}catch(e){
    UpdateSortieLog(e);
}
}

function calcCombinedBattleLog(){
//    UpdateSortieLog("undefined combined battle.")
    let tObjs = KclInfo.gBattle;
//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];
    let nowhpsc = KclInfo.gBattle.api_nowhps_combined;
    let maxhpsc = KclInfo.gBattle.api_maxhps_combined;
    let dmghpsc = [0, 0,0,0,0,0,0 ];
try{
//api_stage_flag
    if(tObjs.api_stage_flag[2] == 1){
        let fdam = tObjs.api_kouku.api_stage3.api_fdam;
        for(let i in fdam){
            if(fdam[+i] != -1){
                dmghps[+i] += parseInt(fdam[+i]);
            }
        }
        let edam = tObjs.api_kouku.api_stage3.api_edam;
        for(let i in edam){
            if(edam[+i] != -1){
                dmghps[+i + 6] += parseInt(edam[+i]);
            }
        }

        let fdam2 = tObjs.api_kouku.api_stage3_combined.api_fdam;
        for(let i in fdam2){
            if(fdam2[+i] != -1){
                dmghpsc[+i] += parseInt(fdam2[+i]);
            }
        }

    }
//api_support_flag
    calcSupportAttack(dmghps, tObjs.api_support_flag, tObjs.api_support_info);
//api_opening_flag
    if(tObjs.api_opening_flag == 1){
        calcCombinedOpeningAttack(dmghps, dmghpsc, tObjs.api_opening_atack);
    }
//api_hourai
    calcCombinedHouraiAttack(dmghps, dmghpsc,
                     tObjs.api_hourai_flag,
                     tObjs.api_hougeki1,
                     tObjs.api_hougeki2,
                     tObjs.api_hougeki3,
                     tObjs.api_raigeki);

    calcCombinedBattleResultLog(dmghps, nowhps, maxhps, dmghpsc, nowhpsc, maxhpsc);
}catch(e){
    UpdateSortieLog(e);
}
}

function calcCombinedWaterBattleLog(){
//    UpdateSortieLog("undefined combined battle.")
    let tObjs = KclInfo.gBattle;
//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];
    let nowhpsc = KclInfo.gBattle.api_nowhps_combined;
    let maxhpsc = KclInfo.gBattle.api_maxhps_combined;
    let dmghpsc = [0, 0,0,0,0,0,0 ];
try{
//api_stage_flag
    if(tObjs.api_stage_flag[2] == 1){
        let fdam = tObjs.api_kouku.api_stage3.api_fdam;
        for(let i in fdam){
            if(fdam[+i] != -1){
                dmghps[+i] += parseInt(fdam[+i]);
            }
        }
        let edam = tObjs.api_kouku.api_stage3.api_edam;
        for(let i in edam){
            if(edam[+i] != -1){
                dmghps[+i + 6] += parseInt(edam[+i]);
            }
        }

        let fdam2 = tObjs.api_kouku.api_stage3_combined.api_fdam;
        for(let i in fdam2){
            if(fdam2[+i] != -1){
                dmghpsc[+i] += parseInt(fdam2[+i]);
            }
        }

    }
//api_support_flag
    calcSupportAttack(dmghps, tObjs.api_support_flag, tObjs.api_support_info);
//api_opening_flag
    if(tObjs.api_opening_flag == 1){
        calcCombinedOpeningAttack(dmghps, dmghpsc, tObjs.api_opening_atack);
    }
//api_hourai
    calcCombinedWaterHouraiAttack(dmghps, dmghpsc,
                     tObjs.api_hourai_flag,
                     tObjs.api_hougeki1,
                     tObjs.api_hougeki2,
                     tObjs.api_hougeki3,
                     tObjs.api_raigeki);

    calcCombinedBattleResultLog(dmghps, nowhps, maxhps, dmghpsc, nowhpsc, maxhpsc);
}catch(e){
    UpdateSortieLog(e);
}
}


function calcCombinedOpeningAttack(dmghps, dmghpsc, tObjs){
    for(let i in tObjs.api_fdam){
        if(tObjs.api_fdam[+i] != -1){
            dmghpsc[+i] += parseInt(tObjs.api_fdam[+i]);
        }
    }
    for(let i in tObjs.api_edam){
        if(tObjs.api_edam[+i] != -1){
            dmghps[+i + 6] += parseInt(tObjs.api_edam[+i]);
        }
    }
    return dmghps;
}


function calcCombinedHouraiAttack(dmghps, dmghpsc, tFlags, tObjs1, tObjs2, tObjs3, tObjs4){
//subfleet canon hougeki1
    if(tFlags[0] == 1){
        for(let i in tObjs1.api_df_list){
            if(tObjs1.api_df_list[+i] instanceof Array){
                for(let k in tObjs1.api_df_list[+i]){
                    let j = +tObjs1.api_df_list[+i][+k];
                    if(tObjs1.api_damage[+i][+k] != -1){
                        if(j < 7){
                            dmghpsc[j] += parseInt(tObjs1.api_damage[+i][+k]);
                        }else{
                            dmghps[j] += parseInt(tObjs1.api_damage[+i][+k]);
                        }
                    }
                }
            }else{
                let j = parseInt(tObjs1.api_df_list[+i]);
                if(tObjs1.api_damage[+i] != -1){
                    if(j < 7){
                        dmghpsc[j] += parseInt(tObjs1.api_damage[+i]);
                    }else{
                        dmghps[j] += parseInt(tObjs1.api_damage[+i]);
                    }
                }
            }
        }
    }
//subfleet torpedo raigeki
    if(tFlags[1] == 1){
        for(let i in tObjs4.api_fdam){
            if(tObjs4.api_fdam[+i] != -1){
                dmghpsc[+i] += parseInt(tObjs4.api_fdam[+i]);
            }
        }
        for(let i in tObjs4.api_edam){
            if(tObjs4.api_edam[+i] != -1){
                dmghps[+i + 6] += parseInt(tObjs4.api_edam[+i]);
            }
        }
    }

//mainfleet canon hougeki2
    if(tFlags[2] == 1){
        for(let i in tObjs2.api_df_list){
            if(tObjs2.api_df_list[+i] instanceof Array){
                for(let k in tObjs2.api_df_list[+i]){
                    let j = +tObjs2.api_df_list[+i][+k];
                    if(tObjs2.api_damage[+i][+k] != -1){
                        dmghps[j] += parseInt(tObjs2.api_damage[+i][+k]);
                    }
                }
            }else{
                let j = +tObjs2.api_df_list[+i];
                if(tObjs2.api_damage[+i] != -1){
                    dmghps[j] += parseInt(tObjs2.api_damage[+i]);
                }
            }
        }
    }

//mainfleet canon2 hougeki3
    if(tFlags[3] == 1){
        for(let i in tObjs3.api_df_list){
            if(tObjs3.api_df_list[+i] instanceof Array){
                for(let k in tObjs3.api_df_list[+i]){
                    let j = +tObjs3.api_df_list[+i][+k];
                    if(tObjs3.api_damage[+i][+k] != -1){
                        dmghps[j] += parseInt(tObjs3.api_damage[+i][+k]);
                    }
                }
            }else{
                let j = +tObjs3.api_df_list[+i];
                if(tObjs3.api_damage[+i] != -1){
                    dmghps[j] += parseInt(tObjs3.api_damage[+i]);
                }
            }
        }
    }

    return dmghps;
}

function calcCombinedWaterHouraiAttack(dmghps, dmghpsc, tFlags, tObjs1, tObjs2, tObjs3, tObjs4){
//mainfleet canon hougeki1
    if(tFlags[0] == 1){
        for(let i in tObjs1.api_df_list){
            if(tObjs1.api_df_list[+i] instanceof Array){
                for(let k in tObjs1.api_df_list[+i]){
                    let j = +tObjs1.api_df_list[+i][+k];
                    if(tObjs1.api_damage[+i][+k] != -1){
                        dmghps[j] += parseInt(tObjs1.api_damage[+i][+k]);
                    }
                }
            }else{
                let j = +tObjs1.api_df_list[+i];
                if(tObjs1.api_damage[+i] != -1){
                    dmghps[j] += parseInt(tObjs1.api_damage[+i]);
                }
            }
        }
    }

//mainfleet canon2 hougeki2
    if(tFlags[1] == 1){
        for(let i in tObjs2.api_df_list){
            if(tObjs2.api_df_list[+i] instanceof Array){
                for(let k in tObjs2.api_df_list[+i]){
                    let j = +tObjs2.api_df_list[+i][+k];
                    if(tObjs2.api_damage[+i][+k] != -1){
                        dmghps[j] += parseInt(tObjs2.api_damage[+i][+k]);
                    }
                }
            }else{
                let j = +tObjs2.api_df_list[+i];
                if(tObjs2.api_damage[+i] != -1){
                    dmghps[j] += parseInt(tObjs2.api_damage[+i]);
                }
            }
        }
    }
//subfleet canon hougeki3
    if(tFlags[2] == 1){
        for(let i in tObjs3.api_df_list){
            if(tObjs3.api_df_list[+i] instanceof Array){
                for(let k in tObjs3.api_df_list[+i]){
                    let j = +tObjs3.api_df_list[+i][+k];
                    if(tObjs3.api_damage[+i][+k] != -1){
                        if(j < 7){
                            dmghpsc[j] += parseInt(tObjs3.api_damage[+i][+k]);
                        }else{
                            dmghps[j] += parseInt(tObjs3.api_damage[+i][+k]);
                        }
                    }
                }
            }else{
                let j = parseInt(tObjs3.api_df_list[+i]);
                if(tObjs3.api_damage[+i] != -1){
                    if(j < 7){
                        dmghpsc[j] += parseInt(tObjs3.api_damage[+i]);
                    }else{
                        dmghps[j] += parseInt(tObjs3.api_damage[+i]);
                    }
                }
            }
        }
    }

//subfleet torpedo raigeki
    if(tFlags[3] == 1){
        for(let i in tObjs4.api_fdam){
            if(tObjs4.api_fdam[+i] != -1){
                dmghpsc[+i] += parseInt(tObjs4.api_fdam[+i]);
            }
        }
        for(let i in tObjs4.api_edam){
            if(tObjs4.api_edam[+i] != -1){
                dmghps[+i + 6] += parseInt(tObjs4.api_edam[+i]);
            }
        }
    }


    return dmghps;
}


function calcCombinedMidnightBattleLog(){
//    UpdateSortieLog("undefined combined midnight battle");
try{
    let tObjs = KclInfo.gBattle.api_hougeki;
//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];
    let nowhpsc = KclInfo.gBattle.api_nowhps_combined;
    let maxhpsc = KclInfo.gBattle.api_maxhps_combined;
    let dmghpsc = [0, 0,0,0,0,0,0 ];

    for(let i in tObjs.api_df_list){
        if(tObjs.api_df_list[+i] instanceof Array){
            for(let k in tObjs.api_df_list[+i]){
                let j = +tObjs.api_df_list[+i][+k];
                if(tObjs.api_damage[+i][+k] != -1){
                    if(j < 7){
                        dmghpsc[j] += parseInt(tObjs.api_damage[+i][+k]);
                    }else{
                        dmghps[j] += parseInt(tObjs.api_damage[+i][+k]);
                    }
                }
            }
        }
    }
    calcCombinedBattleResultLog(dmghps, nowhps, maxhps, dmghpsc, nowhpsc, maxhpsc);
}catch(e){
    UpdateSortieLog(e);
}
}

function UpdateCombinedBattleResultLog(){
//    UpdateSortieLog("undefined combined battle result.");
    UpdateBattleResultLog();

}

function calcCombinedBattleResultLog(dmghps, nowhps, maxhps, dmghpsc, nowhpsc, maxhpsc){
    let fMsg = getBStr("MYFLEET") + "1";
    let fMsg2 = getBStr("MYFLEET") + "2";
    let eMsg = getBStr("ENEMYFLEET");
    let fRatio = [0, 0];
    let fRatio2 = [0, 0];
    let eRatio = [0, 0];
    let dFlag = "";
    let dList = "";

//calculate
    for(let i = 0; i < 13; i++){
        dmghps[i] = nowhps[i] - dmghps[i];
        if(dmghps[i] < 0){dmghps[i] = 0}
    }
    for(let i = 0; i < 7; i++){
        dmghpsc[i] = nowhpsc[i] - dmghpsc[i];
        if(dmghpsc[i] < 0){dmghpsc[i] = 0}
    }

    for(let i = 1; i < 7; i++){
        if(maxhps[i] != -1){
            fMsg += "[" + dmghps[i] + "/" + maxhps[i] + "]";
            fRatio[0] += +dmghps[i];
            fRatio[1] += +nowhps[i];
            let drt = dmghps[i] / maxhps[i];
            if(drt <= 0.25){
                dFlag = getBStr("DMGHIGHRATIO");
            }else if((drt <= 0.5) && (dFlag == "")){
                dFlag = getBStr("DMGMIDRATIO");
            }
        }
    }
    for(let i = 7; i < 13; i++){
        if(maxhps[i] != -1){
            eMsg += "[" + dmghps[i] + "/" + maxhps[i] + "]";
            eRatio[0] += +dmghps[i];
            eRatio[1] += +nowhps[i];
        }
    }
    for(let i = 1; i < 7; i++){
        if(maxhpsc[i] != -1){
            fMsg2 += "[" + dmghpsc[i] + "/" + maxhpsc[i] + "]";
            fRatio2[0] += +dmghpsc[i];
            fRatio2[1] += +nowhpsc[i];
            let drt = dmghpsc[i] / maxhpsc[i];
            if(drt <= 0.25){
                dFlag = getBStr("DMGHIGHRATIO");
            }else if((drt <= 0.5) && (dFlag == "")){
                dFlag = getBStr("DMGMIDRATIO");
            }
        }
    }

// output
    fMsg = (((fRatio[1] - fRatio[0]) / fRatio[1]) * 100).toFixed(1) + "%:" + fMsg
    fMsg2 = (((fRatio2[1] - fRatio2[0]) / fRatio2[1]) * 100).toFixed(1) + "%:" + fMsg2
    eMsg = (((eRatio[1] - eRatio[0]) / eRatio[1]) * 100).toFixed(1) + "%:" + eMsg
    UpdateSortieLog(fMsg);
    UpdateSortieLog(fMsg2);
    UpdateSortieLog(eMsg);
    if(dFlag != ""){
        UpdateSortieLog(dFlag);
    }
    return "";

}


function calcBattleDetailLog(dmghps, nowhps, maxhps){
    let tDT;
    tLog="start\n";
try{
//initialize
    let gBR = KclInfo.gBattle;
    let tDk = gBR.api_dock_id;
    if(typeof tDk === "undefined"){
       tDk = gBR.api_deck_id;
    }
    let tFsp = [-1].concat(KclInfo.gMemberFleet[tDk - 1].api_ship);
    let tEsp = gBR.api_ship_ke;
    let tFmemSp = [];
    let tFmsSp = [];
    let tEmsSp = [];
    for(let i in tFsp){
        tFmemSp.push(SearchMemberShip(tFsp[i]));
        tFmsSp.push(SearchMasterShip(tFsp[i]));
    }
    for(let i in tEsp){
        tEmsSp.push(SearchMasterShipByID(tEsp[i]));
    }

//search
    tDT = gBR.api_search;
    if(typeof tDT !== "undefined"){
        tLog += "search result 1:(" + tDT[0] + ") 2:(" + tDT[1] + ")" + "\n";
    }

//formation
    tDT = gBR.api_formation;
    if(typeof tDT !== "undefined"){
        tLog += "formation. own(" + tDT[0] + ") enemy(" + tDT[1] + ") combat(" + tDT[2] + ")" + "\n";
    }

//air_attack
    tDT = gBR.api_stage_flag;
    if(typeof tDT !== "undefined"){
        tLog += "Air Attack." + "\n";
        if(gBR.api_stage_flag[0] == 1){
            let gST = gBR.api_kouku.api_stage1;
            tLog += "stage1. "
                  + "own("   + gST.api_f_lostcount + "/" + gST.api_f_count + ") "
                  + "enemy(" + gST.api_e_lostcount + "/" + gST.api_e_count + ") "
                  + "air supremacy status(" + gST.api_disp_seiku + ")"
                  + "air touch status(" + gST.api_touch_plane[0] + "/" + gST.api_touch_plane[1] + ")" + "\n";
        }
        if(gBR.api_stage_flag[1] == 1){
            let gST = gBR.api_kouku.api_stage2;
            tLog += "stage2. "
                  + "own("   + gST.api_f_lostcount + "/" + gST.api_f_count + ") "
                  + "enemy(" + gST.api_e_lostcount + "/" + gST.api_e_count + ")" + "\n";
        }
        if(gBR.api_stage_flag[2] == 1){
            let gST = gBR.api_kouku.api_stage3;
            tLog += "stage3." + "\n";
            tLog += "friendly air crafts damages. -> " + JSON.stringify(gST.api_fdam) + "\n";
            tLog += "enemy air crafts damages. -> " + JSON.stringify(gST.api_edam) + "\n";
        }
    }
//opening attack
    if(gBR.api_opening_flag == 1){
        tLog += "opening attack." + "\n";
        let gST = gBR.api_opening_atack;
        for(let i in gST.api_frai){
            if(gST.api_frai[i] >0){
                let fNM = tFmsSp[i].api_name;
                let eNM = tEmsSp[gST.api_frai[i]].api_name;
                if(tEmsSp[gST.api_frai[i]].api_sortno == 0 && tEmsSp[gST.api_frai[i]].api_yomi != "-"){
                    eNM += tEmsSp[gST.api_frai[i]].api_yomi;
                }
                tLog += i + ":" + fNM + " -> " + eNM +  " : " + gST.api_edam[gST.api_frai[i]] + "\n"; 
            }
        }
        for(let i in gST.api_erai){
            if(gST.api_erai[i] >0){
                let eNM = tEmsSp[i].api_name;
                let fNM = tFmsSp[gST.api_erai[i]].api_name;
                if(tEmsSp[i].api_sortno == 0 && tEmsSp[i].api_yomi != "-"){
                    eNM += tEmsSp[i].api_yomi;
                }
                tLog += i + ":" + fNM + " <- " + eNM +  " : " + gST.api_fdam[gST.api_erai[i]] + "\n"; 
            }
        }
        tLog += JSON.stringify(gST.api_fdam) + "\n";
        tLog += JSON.stringify(gST.api_edam) + "\n";
    }
    dID("battlelog").value = tLog;
}catch(e){
    dID("battlelog").value = "aborted.\n" + tLog;
}
}


function writeToFile(filename, content){
    try{
        let gLogFile = filename;
        let tDate = new Date();
        gLogFile = gLogFile.replace(/\%YYYY\%/ig,tDate.getFullYear());
        gLogFile = gLogFile.replace(/\%MM\%/ig,("0" + (tDate.getMonth() + 1)).slice(-2));
        gLogFile = gLogFile.replace(/\%DD\%/ig,("0" + (tDate.getDate())).slice(-2));

        let file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        file.initWithPath(gLogFile);
        if(! file.exists()){
            file.create(0, parseInt("0664",8));
        }

        let out = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
        out.init(file, 0x10 | 0x02, parseInt("0664",8), null);
        let charset = "UTF-8";
        let conv = Cc["\@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);

        conv.init(out, charset, 0, 0x0000);
        conv.writeString(content);
        conv.close();

    }catch(e){
        throw e;
    }
}

function writeToFileBin(filename, content, rmode){
    if(typeof rmode === "undefined"){
        rmode = "o";
    }
    try{
        let gLogFile = filename;
        let file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        file.initWithPath(gLogFile);
        if(! file.exists()){
            file.create(0, parseInt("0664",8));
        }else if(rmode != "o"){
            return;
        }

        let out = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
        out.init(file, -1, parseInt("0664",8), null);
        let charset = "UTF-8";
        let bins = Cc["@mozilla.org/binaryoutputstream;1"].createInstance(Ci.nsIBinaryOutputStream);

        bins.setOutputStream(out);
        bins.writeBytes(content , content.length);
//        bins.writeByteArray(content , content.length);
        bins.close();
    }catch(e){
debugprint("writeToFileBin error : " + e);
        throw e;
    }
}

function setKclEnemySetsPref(){
    try{
        let prefPath = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
        prefPath.append("kclinsp.enemysets.perf");
        let file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        file.initWithPath(prefPath.path);
        if(! file.exists()){
            file.create(0, parseInt("0664",8));
        }

        let out = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
        out.init(file, 0x02 | 0x20, parseInt("0664",8), null);
        let charset = "UTF-8";
        let conv = Cc["\@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);

        conv.init(out, charset, 0, 0x0000);
        conv.writeString(JSON.stringify(eData));
        conv.close();
    }catch(e){
        throw e;
    }
}

function getKclEnemySetsPref(){
    try{
        let prefPath = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
        prefPath.append("kclinsp.enemysets.perf");
        let file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        file.initWithPath(prefPath.path);
        if(! file.exists()){
            file.create(0, parseInt("0664",8));
            eData = {};
            eData['edata'] = [];
            eData.edata.push(JSON.parse(defEnemySet));
            setKclEnemySetsPref()
        }

        let data = "";
        let fstream = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
        let sstream = Cc["@mozilla.org/scriptableinputstream;1"].createInstance(Ci.nsIScriptableInputStream);
        fstream.init(file, -1, 0, 0);
        sstream.init(fstream); 

        let str = sstream.read(4096);
        while(str.length > 0){
          data += str;
          str = sstream.read(4096);
        }

        sstream.close();
        fstream.close();
        eData = JSON.parse(data);

    }catch(e){
        throw e
    }

}

function getBStr(keyword){
   try{
      return bundle.getString(keyword);
   }catch(e){
      return "keyword error:" + keyword + "[" + e + "]";
   }
}

function InitConfig(){
    let keys = hw_Branch.getChildList("");
    for(let i in keys){
        hw_Branch.clearUserPref(keys[i]);
    }

    eData = {};
    eData['edata'] = [];
    eData.edata.push(JSON.parse(defEnemySet));

    removeLocalFile("kclinsp.enemysets.perf");
    removeLocalFile("kclinsp.api_start2.pref");

}

function removeLocalFile(target){
    try{
        let prefPath = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
        prefPath.append(target);
        let file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        file.initWithPath(prefPath.path);
        if(file.exists()){
            file.remove(false);
        }
    }catch(e){
        UpdateSortieLog(e)
    }
}

function ShipDetailPanel(tObjs){
    let tItem = (dID("ShipTree")).currentIndex;
    let shipid = gShipTreeList2[tItem].api_id;


    let memShip = SearchMemberShip(shipid);
    let msShip = SearchMasterShip(shipid);
    dID("shiplsname").value = msShip.api_name;
    dID("shiplslv").value = memShip.api_lv;
    dID("shiplsstatus").value = "[" + memShip.api_nowhp + "/" + memShip.api_maxhp + "]";
    dID("shiplsexp").value = "[" + +memShip.api_exp[0] + "/" + (+memShip.api_exp[1] + +memShip.api_exp[0]) + "@" + +memShip.api_exp[1] + "]";
    dID("shiplsequip1").value = SearchMemberItemObj(memShip.api_slot[0]).api_name;
    dID("shiplsequip2").value = SearchMemberItemObj(memShip.api_slot[1]).api_name;
    dID("shiplsequip3").value = SearchMemberItemObj(memShip.api_slot[2]).api_name;
    dID("shiplsequip4").value = SearchMemberItemObj(memShip.api_slot[3]).api_name;
    dID("shiplsequip5").value = SearchMemberItemObj(memShip.api_slot[4]).api_name;

}

function UpdateMissionLog(tObj1, tObj2){
try{
    let dispexpedstart = hw_Branch.getBoolPref("dispexpedstart");
    if(dispexpedstart == false){
        return "";
    }
    let mObj = getMissionObj(tObj2.api_mission_id);
    let str = getBStr("EXPFLEET") + 
              KclInfo.gMemberFleet[+tObj2.api_deck_id - 1].api_name + " " +
              getBStr("EXPTARGET") + 
              mObj.api_name + " " +
              getBStr("EXPRETURN") + 
              tObj1.api_data.api_complatetime_str;
    UpdateSortieLog(str);
}catch(e){
    UpdateSortieLog(e);
}

}

function getMissionObj(number){
    for(let i in KclInfo.gapi_start2.api_data.api_mst_mission){
        if(KclInfo.gapi_start2.api_data.api_mst_mission[i].api_id == number){
            return KclInfo.gapi_start2.api_data.api_mst_mission[i];
        }
    }
    return undefined;
}

function setBasicPref(tObj){
    try{
        let prefPath = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
        prefPath.append("kclinsp.api_start2.pref");
        let file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        file.initWithPath(prefPath.path);
        if(! file.exists()){
            file.create(0, parseInt("0664",8));
        }

        let out = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
        out.init(file, 0x02 | 0x20, parseInt("0664",8), null);
        let charset = "UTF-8";
        let conv = Cc["\@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);

        conv.init(out, charset, 0, 0x0000);
        conv.writeString(JSON.stringify(tObj));
        conv.close();

    }catch(e){
        throw e;
    }
}

function getBasicPref(){
    if(typeof KclInfo.gapi_start2.api_data !== "undefined"){
        return;
    }
    try{
        let prefPath = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
        prefPath.append("kclinsp.api_start2.pref");
        let file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
        file.initWithPath(prefPath.path);
        if(! file.exists()){
            return;
        }

        let data = "";
        let fstream = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
        let sstream = Cc["@mozilla.org/scriptableinputstream;1"].createInstance(Ci.nsIScriptableInputStream);
        let conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Ci.nsIScriptableUnicodeConverter);
        conv.charset = "UTF-8";
        fstream.init(file, -1, 0, 0);
        sstream.init(fstream); 

        let str = sstream.read(4096);
        while(str.length > 0){
            data += conv.ConvertToUnicode(str);
            str = sstream.read(4096);
        }

        sstream.close();
        fstream.close();

        KclInfo.gapi_start2 = JSON.parse(data);
        KclInfo.gMasterShip = KclInfo.gapi_start2.api_data.api_mst_ship;
        KclInfo.gMasterItem = KclInfo.gapi_start2.api_data.api_mst_slotitem;
        KclInfo.gMapInfo = KclInfo.gapi_start2.api_data.api_mst_mapinfo;
        KclInfo.gMapCell = KclInfo.gapi_start2.api_data.api_mst_mapcell;
        KclInfo.gMasterQuestList = KclInfo.gapi_start2.api_data.api_mst_mission;

    }catch(e){
        throw e
    }
}


window.addEventListener("load", function(e){KclInsp.init();}, false);
window.addEventListener("unload", function(e){KclInsp.destroy();}, false);
